/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryItemHighlightType_$type } from "./CategoryItemHighlightType";
import { MarkerType_$type } from "./MarkerType";
import { Brush } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Base, enumGetBox, fromEnum, typeCast, Point_$type, markType, markDep, runOn } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { List$1 } from "igniteui-angular-core";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Rect } from "igniteui-angular-core";
import { MarkerSeries } from "./MarkerSeries";
import { DataContext } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, truncate } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Marker } from "./Marker";
import { BrushUtil } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { DataTemplatePassInfo } from "igniteui-angular-core";
import { DataTemplateRenderInfo } from "igniteui-angular-core";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
/**
 * @hidden
 */
export class CategoryItemHighlightLayer extends AnnotationLayer {
    constructor() {
        super();
        this.pj = false;
        this.pi = true;
        this.pm = 10;
        let a = new CategoryItemHighlightLayerFrame();
        let b = new CategoryItemHighlightLayerFrame();
        let c = new CategoryItemHighlightLayerFrame();
        this.ob = a;
        this.oa = b;
        this.oc = c;
        this.ab = CategoryItemHighlightLayer.$;
    }
    bp() {
        return new CategoryItemHighlightLayerView(this);
    }
    kk(a) {
        super.kk(a);
        this.pd = a;
    }
    ou(a, b) {
        if (this.ph == null || this.ph == a) {
            if (!this.ar.c) {
                this.k3(b);
            }
        }
    }
    oh(a) {
        if (!super.oh(a)) {
            return false;
        }
        if (this.pv != null) {
            if (a.c7) {
                let b = a.ib();
                if (!Base.equalsStatic(this.pv, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.pv, a.name)) {
                    return false;
                }
            }
        }
        let c = this.op(a);
        if (!c.c) {
            return false;
        }
        return true;
    }
    ow(a, b) {
        super.ow(a, b);
        let c = a;
        let d = this.pl;
        c.g.clear();
        if (isNaN_(this.pa.x) && isNaN_(this.pa.y)) {
            return;
        }
        if (this.oh(this.ph)) {
            this.p1(this.ph, c, d);
        }
        else {
            for (let e of fromEnum(this.b6.series)) {
                if (this.oh(e)) {
                    this.p1(e, c, d);
                }
                if (e.isStacked) {
                    e.jy((f) => {
                        if (this.oh(f)) {
                            this.p1(f, c, d);
                        }
                        return true;
                    });
                }
            }
        }
    }
    kp(a, b, c, d) {
        super.kp(a, b, c, d);
        switch (b) {
            case CategoryItemHighlightLayer.$$p[4]:
            case CategoryItemHighlightLayer.$$p[5]:
            case CategoryItemHighlightLayer.$$p[2]:
            case CategoryItemHighlightLayer.$$p[3]:
                this.k3(true);
                break;
            case CategoryItemHighlightLayer.$$p[7]:
            case CategoryItemHighlightLayer.$$p[8]:
                this.k3(true);
                break;
            case CategoryItemHighlightLayer.$$p[9]:
                this.pj = d;
                this.k3(true);
                break;
            case CategoryItemHighlightLayer.$$p[1]:
                this.k3(true);
                break;
            case CategoryItemHighlightLayer.$$p[0]:
                this.pm = this.pn;
                this.k3(true);
                break;
            case CategoryItemHighlightLayer.$$p[6]:
                this.pi = d;
                this.k3(true);
                break;
        }
    }
    p1(a, b, c) {
        if (this.bs == null || this.bs.bv.isEmpty || this.bs.bu.isEmpty) {
            return;
        }
        if (!a.cz && !a.c6) {
            return;
        }
        let d = a;
        if (d.categoryAxis == null) {
            return;
        }
        let e = this.pa.x;
        e = this.bs.bu.left + this.bs.bu.width * (e - this.bs.bv.left) / this.bs.bv.width;
        let f = this.pa.y;
        f = this.bs.bu.top + this.bs.bu.height * (f - this.bs.bv.top) / this.bs.bv.height;
        let g = this.pk;
        let h = true;
        let i = typeCast(IHasCategoryModePreference_$type, a);
        let j = 0;
        if (i != null) {
            j = i.preferredCategoryMode(d.categoryAxis);
            if (j == 2) {
                h = false;
            }
        }
        let k = true;
        if (!h || this.pe == 2) {
            k = false;
        }
        if (this.pe == 1) {
            k = true;
        }
        let l = this.op(a);
        if (!l.c) {
            return;
        }
        if (k) {
            let m = a.nt(l.d, this.pl, g);
            if (j != 0 && !d.categoryAxis.cf) {
                let n = m.x;
                if (a.c6) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
                else if (a.cz) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
            }
            if (!isNaN_(m.x) && !isNaN_(m.y)) {
                m = this.nw(m);
            }
            this.pz(m, b, a);
        }
        else {
            let o = a.nt(l.d, this.pl, g);
            let p;
            let q = this.getEffectiveViewport1(this.bs);
            if (a.isVertical) {
                let r = o.y;
                let s = d.categoryAxis;
                let t = this.pm;
                if (j != 0) {
                    t = s.j0(this.bs.bv, this.bs.bu, q);
                }
                if (isNaN_(t) || isInfinity(t)) {
                    return;
                }
                p = new Rect(0, this.n6.left, r - t / 2, this.n6.width, t);
            }
            else {
                let u = o.x;
                let v = d.categoryAxis;
                let w = this.pm;
                if (j != 0) {
                    w = v.j0(this.bs.bv, this.bs.bu, q);
                }
                if (isNaN_(w) || isInfinity(w)) {
                    return;
                }
                p = new Rect(0, u - w / 2, this.n6.top, w, this.n6.height);
            }
            p.intersect(this.bs.bu);
            this.p0(p, b, a);
        }
    }
    pz(a, b, c) {
        let d = new ItemHighlightFrameRect();
        d.b = a.x;
        d.e = a.y;
        d.i = this.o8();
        if (this.qf != null) {
            d.i = this.qf;
        }
        d.j = this.o9();
        if (this.qg != null) {
            d.j = this.qg;
        }
        if (d.i == null) {
            if (c.hasMarkers) {
                d.i = this.pd.ci(c.ne());
            }
            else {
                d.i = this.pd.ci(c.m9);
            }
        }
        if (d.j == null) {
            if (c.hasMarkers) {
                d.j = this.pd.ci(c.nf());
            }
            else {
                d.j = this.pd.ci(c.na);
            }
        }
        d.d = this.eu;
        d.f = Base.getHashCodeStatic(c);
        d.g = this.pf(c, a);
        let e = (typeCast(MarkerSeries.$, c) !== null) ? c.o3 : null;
        if (e == null || e == MarkerSeries.o6 || (this.pg != 2 && this.pg != 0)) {
            let f = MarkerSeries.oj(c, 2);
            if (this.pg != 2 && this.pg != 0) {
                f = this.pg;
            }
            switch (f) {
                case 3:
                case 13:
                    e = this.b6.me;
                    break;
                case 4:
                    e = this.b6.mn;
                    break;
                case 5:
                    e = this.b6.mk;
                    break;
                case 6:
                    e = this.b6.ml;
                    break;
                case 7:
                    e = this.b6.mf;
                    break;
                case 8:
                    e = this.b6.mi;
                    break;
                case 9:
                    e = this.b6.mg;
                    break;
                case 10:
                    e = this.b6.mm;
                    break;
                case 11:
                    e = this.b6.mj;
                    break;
                case 12:
                    e = this.b6.mh;
                    break;
            }
        }
        d.h = this.p4 != null ? this.p4 : e;
        if (!isNaN_(d.b) && !isNaN_(d.e)) {
            b.g.addItem(d.f, d);
        }
    }
    pf(a, b) {
        let c = a.gq(b);
        let d = a.e4(b);
        if (this.pl && d != Math.floor(d)) {
            c = null;
        }
        return ((() => {
            let $ret = new DataContext();
            $ret.series = a;
            $ret.item = c;
            return $ret;
        })());
    }
    p0(a, b, c) {
        let d = new ItemHighlightFrameRect();
        d.b = a.left;
        d.e = a.top;
        d.c = a.right;
        d.a = a.bottom;
        d.i = this.o8();
        d.j = this.o9();
        if (d.i == null) {
            if (c != null) {
                d.i = this.pd.cj(c.m9);
            }
        }
        if (d.j == null) {
            if (c != null) {
                d.j = this.pd.cj(c.na);
            }
        }
        d.d = this.eu;
        d.f = Base.getHashCodeStatic(c);
        if (!a.isEmpty) {
            b.g.addItem(d.f, d);
        }
    }
    oz(a, b) {
        super.oz(a, b);
        let c = this.pd.b6;
        let d = this.pd.b5;
        let e = 0;
        let f = 0;
        let g = a;
        for (let h of fromEnum(g.g.values)) {
            if (h.h != null) {
                let i = d.item(f);
                this.p2(h, i);
                f++;
            }
            else {
                let j = c.item(e);
                this.p3(h, j);
                e++;
            }
        }
        c.count = e;
        d.count = f;
    }
    p2(a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.d) || a.g == null) {
            b._visibility = 1;
            return;
        }
        let c = { $type: Point_$type, x: a.b, y: a.e };
        let d = a.g;
        d.itemBrush = a.i;
        let e = d.series.nt(c, this.cn() || this.pj, this.pi);
        if (isNaN_(e.x) || isNaN_(e.y)) {
            b._visibility = 1;
            return;
        }
        this.pd.cc(b, e.x, e.y);
        b.ah = a.h;
        b.content = a.g;
    }
    p3(a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
            b._visibility = 1;
            return;
        }
        this.pd.cd(b, a.b, a.e, a.c - a.b, a.a - a.e);
        b._fill = a.i;
        b._stroke = a.j;
        b.ac = a.d;
        if (this.nj != null) {
            b.ai = this.nj;
        }
        else {
            b.ai = null;
        }
        b.ad = this.nk;
    }
    dp() {
        return true;
    }
}
CategoryItemHighlightLayer.$t = markType(CategoryItemHighlightLayer, 'CategoryItemHighlightLayer', AnnotationLayer.$);
CategoryItemHighlightLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryItemHighlightLayer, 'raisePropertyChanged', ['BandHighlightWidth:pn:p5', [1, 10], 'HighlightType:pe:p6', [CategoryItemHighlightType_$type, enumGetBox(CategoryItemHighlightType_$type, 0)], 'MarkerBrush:qf:p7', [Brush.$, null], 'MarkerOutline:qg:p8', [Brush.$, null], 'MarkerTemplate:p4:p9', [DataTemplate.$, null], 'MarkerType:pg:qa', [MarkerType_$type, enumGetBox(MarkerType_$type, 2)], 'SkipUnknownValues:pk:qb', [0, true], 'TargetSeriesName:pv:qc', [2, null], 'TargetSeries:ph:qd', [Series.$, null], 'UseInterpolation:pl:qe', [0, false]]);
/**
 * @hidden
 */
export class CategoryItemHighlightLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b4 = null;
        this.b6 = null;
        this.b5 = null;
        this.b7 = null;
        this.b8 = null;
        this.b4 = a;
        this.b7 = new List$1(ContentControl.$, 0);
        this.b8 = new List$1(Rectangle.$, 0);
    }
    as() {
        super.as();
        this.b6 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.ck);
            $ret.activate = runOn(this, this.ce);
            $ret.disactivate = runOn(this, this.cg);
            $ret.destroy = runOn(this, this.cf);
            return $ret;
        })());
        this.b5 = ((() => {
            let $ret = new Pool$1(ContentControl.$);
            $ret.create = runOn(this, this.ch);
            $ret.activate = runOn(this, this.b9);
            $ret.disactivate = runOn(this, this.cb);
            $ret.destroy = runOn(this, this.ca);
            return $ret;
        })());
    }
    ck() {
        let a = new Rectangle();
        a.ab = false;
        this.b8.add(a);
        return a;
    }
    ce(a) {
        a._visibility = 0;
    }
    cg(a) {
        a._visibility = 1;
    }
    cf(a) {
        this.b8.remove(a);
    }
    ch() {
        let a = new Marker();
        this.b7.add(a);
        return a;
    }
    b9(a) {
        a._visibility = 0;
    }
    cb(a) {
        a._visibility = 1;
    }
    ca(a) {
        this.b7.remove(a);
    }
    ci(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.3);
    }
    cj(a) {
        if (a != null) {
            let b = BrushUtil.l(a, 0.3);
            if (b.isGradient) {
                let c = b;
                if (c.gradientStops != null) {
                    for (let d = 0; d < c.gradientStops.length; d++) {
                        let e = c.gradientStops[d];
                        e.color = Color.u(truncate(Math.round((e.color.l) * 0.3)), e.color.o, e.color.n, e.color.m);
                        e.color = e.color;
                    }
                }
            }
            else {
                b.color = Color.u(truncate(Math.round((b.color.l & 255) * 0.3)), b.color.o, b.color.n, b.color.m);
                b.color = b.color;
            }
            return b;
        }
        else {
            return null;
        }
    }
    cd(a, b, c, d, e) {
        a._visibility = 0;
        a.n = b;
        a.o = c;
        a.width = d;
        a.height = e;
    }
    cc(a, b, c) {
        a.n = b;
        a.o = c;
    }
    bh(a, b) {
        super.bh(a, b);
        let c = a;
        let d = c.content;
        if (d != null) {
            if (d.itemBrush != null) {
                d.actualItemBrush = d.itemBrush;
            }
            let e = d.series;
            if (e.hasMarkers) {
                d.outline = e.nf();
            }
            d.thickness = e.fc();
        }
    }
    a6(a, b) {
        super.a6(a, b);
        if (a.d && !b) {
            for (let c = 0; c < this.b8.count; c++) {
                let d = this.b8._inner[c];
                if (d._visibility == 0) {
                    a.v(d);
                }
            }
            if (this.b7.count > 0) {
                let e = new DataTemplatePassInfo();
                e.isHitTestRender = b;
                e.context = a.g();
                e.viewportTop = this.bu.top;
                e.viewportLeft = this.bu.left;
                e.viewportWidth = this.bu.width;
                e.viewportHeight = this.bu.height;
                e.passID = "ItemMarkers";
                let f = new DataTemplateRenderInfo();
                f.isHitTestRender = b;
                f.passInfo = e;
                let g = new DataTemplateMeasureInfo();
                g.passInfo = e;
                let h = false;
                let i = a.g();
                g.context = i;
                f.context = i;
                g.renderContext = a;
                f.renderContext = a;
                let j = 0;
                let k = 0;
                let l = new Dictionary$2(DataTemplate.$, DataTemplate.$, 0);
                for (let m = 0; m < this.b7.count; m++) {
                    let n = this.b7._inner[m];
                    let o = n.ah;
                    if (!l.containsKey(o)) {
                        l.addItem(o, o);
                        if (o != null && o.passStarting != null) {
                            o.passStarting(e);
                        }
                    }
                    if (n._visibility == 1) {
                        continue;
                    }
                    this.bg(n, m, b);
                    if (!h) {
                        g.data = n.content;
                        g.width = n.width;
                        g.height = n.height;
                        if (o.measure != null) {
                            g.data = n.content;
                            o.measure(g);
                            h = g.isConstant;
                            if (h) {
                                j = g.width;
                                k = g.height;
                            }
                        }
                        f.availableWidth = g.width;
                        f.availableHeight = g.height;
                    }
                    else {
                        f.availableWidth = j;
                        f.availableHeight = k;
                    }
                    if (!isNaN_(n.width) && !isInfinity(n.width)) {
                        f.availableWidth = n.width;
                    }
                    if (!isNaN_(n.height) && !isInfinity(n.height)) {
                        f.availableHeight = n.height;
                    }
                    a.p(f, n);
                    n.m = f.availableWidth;
                    n.l = f.availableHeight;
                }
                for (let p of fromEnum(l.keys)) {
                    if (p != null && p.passCompleted != null) {
                        p.passCompleted(e);
                    }
                }
            }
        }
    }
    al(a) {
        super.al(a);
        for (let b = 0; b < this.b8.count; b++) {
            this.e.a5.exportRectangleData(a, this.b8._inner[b], "catItemRect", ["Main", "CategoryItem"]);
        }
        for (let c = 0; c < this.b7.count; c++) {
            this.e.a5.exportMarkerVisualDataFromMarker(this.e, a, this.b7._inner[c]);
        }
    }
}
CategoryItemHighlightLayerView.$t = markType(CategoryItemHighlightLayerView, 'CategoryItemHighlightLayerView', AnnotationLayerView.$);
//# sourceMappingURL=CategoryItemHighlightLayer_combined.js.map