/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { ChaikinOscillatorIndicatorStrategy } from "./ChaikinOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class ChaikinOscillatorIndicator extends StrategyBasedIndicator {
    get_sk() {
        return new ChaikinOscillatorIndicatorStrategy();
    }
    get sk() {
        return this.get_sk();
    }
    get_sx() {
        return ChaikinOscillatorIndicator.$;
    }
    get sx() {
        return this.get_sx();
    }
    get shortPeriod() {
        return typeGetValue(this.c(ChaikinOscillatorIndicator.s6));
    }
    set shortPeriod(a) {
        this.h(ChaikinOscillatorIndicator.s6, a);
    }
    ss() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(ChaikinOscillatorIndicator.s5));
    }
    set longPeriod(a) {
        this.h(ChaikinOscillatorIndicator.s5, a);
    }
    sp() {
        return this.longPeriod;
    }
}
ChaikinOscillatorIndicator.$t = markType(ChaikinOscillatorIndicator, 'ChaikinOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
ChaikinOscillatorIndicator.s6 = StrategyBasedIndicator.s4(3, ChaikinOscillatorIndicator.$);
ChaikinOscillatorIndicator.s5 = StrategyBasedIndicator.s0(10, ChaikinOscillatorIndicator.$);
//# sourceMappingURL=ChaikinOscillatorIndicator.js.map