/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { CommodityChannelIndexIndicatorStrategy } from "./CommodityChannelIndexIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class CommodityChannelIndexIndicator extends StrategyBasedIndicator {
    get_sk() {
        return new CommodityChannelIndexIndicatorStrategy();
    }
    get sk() {
        return this.get_sk();
    }
    get_sx() {
        return CommodityChannelIndexIndicator.$;
    }
    get sx() {
        return this.get_sx();
    }
    get s5() {
        return typeGetValue(this.c(CommodityChannelIndexIndicator.s6));
    }
    set s5(a) {
        this.h(CommodityChannelIndexIndicator.s6, a);
    }
    sq() {
        return this.s5;
    }
    sz(a) {
        this.s5 = a;
    }
}
CommodityChannelIndexIndicator.$t = markType(CommodityChannelIndexIndicator, 'CommodityChannelIndexIndicator', StrategyBasedIndicator.$);
CommodityChannelIndexIndicator.s6 = StrategyBasedIndicator.s2(20, CommodityChannelIndexIndicator.$);
//# sourceMappingURL=CommodityChannelIndexIndicator.js.map