/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, getInstanceType } from "igniteui-angular-core";
import { IFinancialPriceSeriesProxy_$type } from "./IFinancialPriceSeriesProxy";
import { stringEndsWith } from "igniteui-angular-core";
/**
 * @hidden
 */
export class FinancialPriceSeriesProxy extends Base {
    getCloseMemberPath(a) {
        return a.qk;
    }
    getHighMemberPath(a) {
        return a.qn;
    }
    getLowMemberPath(a) {
        return a.qs;
    }
    getOpenMemberPath(a) {
        return a.qw;
    }
    getVolumeMemberPath(a) {
        return a.q0;
    }
    matchesType(a) {
        if (!a.c6) {
            return false;
        }
        if (stringEndsWith(getInstanceType(a).typeName, "Indicator") || stringEndsWith(getInstanceType(a).typeName, "Overlay")) {
            return false;
        }
        return true;
    }
    setCategoryMode(a, b) {
        a.oo = b;
    }
    setCloseMemberPath(a, b) {
        a.qk = b;
    }
    setDisplayType(a, b) {
        a.rs = b;
    }
    setHighMemberPath(a, b) {
        a.qn = b;
    }
    setLowMemberPath(a, b) {
        a.qs = b;
    }
    setOpenMemberPath(a, b) {
        a.qw = b;
    }
    setVolumeMemberPath(a, b) {
        a.q0 = b;
    }
    setXAxis(a, b) {
        a.oh = b;
    }
    setYAxis(a, b) {
        a.o2 = b;
    }
}
FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);
//# sourceMappingURL=FinancialPriceSeriesProxy.js.map