/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { MovingAverageConvergenceDivergenceIndicatorStrategy } from "./MovingAverageConvergenceDivergenceIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
export class MovingAverageConvergenceDivergenceIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 9;
        this.rs = 1;
    }
    get_sk() {
        return new MovingAverageConvergenceDivergenceIndicatorStrategy();
    }
    get sk() {
        return this.get_sk();
    }
    get_sx() {
        return MovingAverageConvergenceDivergenceIndicator.$;
    }
    get sx() {
        return this.get_sx();
    }
    get shortPeriod() {
        return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.s8));
    }
    set shortPeriod(a) {
        this.h(MovingAverageConvergenceDivergenceIndicator.s8, a);
    }
    ss() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.s7));
    }
    set longPeriod(a) {
        this.h(MovingAverageConvergenceDivergenceIndicator.s7, a);
    }
    sp() {
        return this.longPeriod;
    }
    get signalPeriod() {
        return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.s9));
    }
    set signalPeriod(a) {
        this.h(MovingAverageConvergenceDivergenceIndicator.s9, a);
    }
    r0() {
        return this.signalPeriod;
    }
}
MovingAverageConvergenceDivergenceIndicator.$t = markType(MovingAverageConvergenceDivergenceIndicator, 'MovingAverageConvergenceDivergenceIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
MovingAverageConvergenceDivergenceIndicator.s8 = StrategyBasedIndicator.s4(10, MovingAverageConvergenceDivergenceIndicator.$);
MovingAverageConvergenceDivergenceIndicator.s7 = StrategyBasedIndicator.s0(30, MovingAverageConvergenceDivergenceIndicator.$);
MovingAverageConvergenceDivergenceIndicator.s9 = StrategyBasedIndicator.s3(9, MovingAverageConvergenceDivergenceIndicator.$, "SignalPeriod");
//# sourceMappingURL=MovingAverageConvergenceDivergenceIndicator.js.map