/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, getInstanceType } from "igniteui-angular-core";
import { IOverlayProxy_$type } from "./IOverlayProxy";
import { stringEndsWith } from "igniteui-angular-core";
/**
 * @hidden
 */
export class OverlayProxy extends Base {
    matchesType(a) {
        if (stringEndsWith(getInstanceType(a).typeName, "Overlay")) {
            return true;
        }
        return false;
    }
    setCloseMemberPath(a, b) {
        a.qk = b;
    }
    setHighMemberPath(a, b) {
        a.qn = b;
    }
    setLowMemberPath(a, b) {
        a.qs = b;
    }
    setMultiplier(a, b) {
        if (getInstanceType(a).typeName == "BollingerBandsOverlay") {
            let s_ = a;
            let p_ = b;
            s_['multiplier'] = p_;
        }
    }
    setOpenMemberPath(a, b) {
        a.qw = b;
    }
    setVolumeMemberPath(a, b) {
        a.q0 = b;
    }
    setXAxis(a, b) {
        a.oh = b;
    }
    setYAxis(a, b) {
        a.o2 = b;
    }
}
OverlayProxy.$t = markType(OverlayProxy, 'OverlayProxy', Base.$, [IOverlayProxy_$type]);
//# sourceMappingURL=OverlayProxy.js.map