/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { markType } from "igniteui-angular-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export class PointSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.ab = PointSeries.$;
    }
    bp() {
        return new PointSeriesView(this);
    }
    kk(a) {
        super.kk(a);
        this.s6 = a;
    }
    fr() {
        return 0.7;
    }
    oc() {
        if (this.ob == 0) {
            return 2;
        }
        return super.oc();
    }
    dy(a, b) {
        let c = this.nt(this.nw(a), true, false);
        if (this.ol(a, b)) {
            return true;
        }
        return false;
    }
    kp(a, b, c, d) {
        super.kp(a, b, c, d);
    }
    get_dd() {
        return false;
    }
    get useHighMarkerFidelity() {
        return this.qp;
    }
}
PointSeries.$t = markType(PointSeries, 'PointSeries', HorizontalAnchoredCategorySeries.$);
/**
 * @hidden
 */
export class PointSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.da = null;
        this.da = a;
    }
    as() {
        super.as();
        if (!this.q) {
            this.b1.oi = 2;
            this.e.bx = 4;
        }
    }
    af() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.ni = a;
        this.e.fs = 3;
        this.e.ft = 2;
        this.e.fu = 2;
        this.e.ea = false;
    }
}
PointSeriesView.$t = markType(PointSeriesView, 'PointSeriesView', AnchoredCategorySeriesView.$);
//# sourceMappingURL=PointSeries_combined.js.map