/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { markType } from "igniteui-angular-core";
import { ScatterFrame } from "./ScatterFrame";
import { ScatterBaseView } from "./ScatterBaseView";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export class ScatterSeries extends ScatterBase {
    constructor() {
        super();
        this.ab = ScatterSeries.$;
        this.p8 = new ScatterFrame();
        this.qa = new ScatterFrame();
        this.p7 = new ScatterFrame();
    }
    bp() {
        return new ScatterSeriesView(this);
    }
    fr() {
        return 0.7;
    }
    oc() {
        if (this.ob == 0) {
            return 2;
        }
        return super.oc();
    }
    kk(a) {
        super.kk(a);
        this.sv = a;
    }
    get_dd() {
        return false;
    }
}
ScatterSeries.$t = markType(ScatterSeries, 'ScatterSeries', ScatterBase.$);
/**
 * @hidden
 */
export class ScatterSeriesView extends ScatterBaseView {
    constructor(a) {
        super(a);
        this.df = null;
        this.df = a;
    }
    as() {
        super.as();
        if (!this.q) {
            this.b1.oi = 2;
            this.e.bx = 4;
        }
    }
    af() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.ni = a;
        this.e.fs = 3;
        this.e.ft = 2;
        this.e.fu = 2;
        this.e.ea = false;
    }
}
ScatterSeriesView.$t = markType(ScatterSeriesView, 'ScatterSeriesView', ScatterBaseView.$);
//# sourceMappingURL=ScatterSeries_combined.js.map