/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { PolarLineSeriesBase } from "./PolarLineSeriesBase";
import { DependencyProperty } from "igniteui-angular-core";
import { runOn, markType, markDep } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { PolarLineSeriesBaseView } from "./PolarLineSeriesBaseView";
import { PathGeometry } from "igniteui-angular-core";
import { Extensions } from "igniteui-angular-core";
import { Numeric } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var PolarSplineAreaSeries = /** @class */ (function (_super) {
    tslib_1.__extends(PolarSplineAreaSeries, _super);
    function PolarSplineAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PolarSplineAreaSeries.$;
        return _this;
    }
    PolarSplineAreaSeries.prototype.bp = function () {
        return new PolarSplineAreaSeriesView(this);
    };
    PolarSplineAreaSeries.prototype.kk = function (a) {
        _super.prototype.kk.call(this, a);
        this.s9 = a;
    };
    PolarSplineAreaSeries.prototype.s7 = function (a) {
        var b = a;
        b.c5();
    };
    PolarSplineAreaSeries.prototype.s8 = function (a, b) {
        this.s7(b);
        if (a.m.count < 1) {
            return;
        }
        var c = b;
        c.c6(a.m, this.ta);
        this.qb.ax(this, this.qy(), runOn(this, this.pp));
        var d = false;
        var e = this.qb.b;
        if (e != null) {
            d = true;
        }
        if (d) {
            this.ry(-1, this.qk.count, b.q);
        }
        var f = c.dc;
        var g = c.db;
        this.qb.ad(f, true, false, true, true);
        this.qb.ad(g, false, true, false, false);
        g._opacity = this.qb.j * this.er;
    };
    PolarSplineAreaSeries.prototype.get_s4 = function () {
        return true;
    };
    PolarSplineAreaSeries.prototype.kp = function (a, b, c, d) {
        _super.prototype.kp.call(this, a, b, c, d);
        switch (b) {
            case PolarSplineAreaSeries.$$p[0]:
                this.k3(false);
                break;
        }
    };
    PolarSplineAreaSeries.$t = markType(PolarSplineAreaSeries, 'PolarSplineAreaSeries', PolarLineSeriesBase.$);
    PolarSplineAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarSplineAreaSeries, 'raisePropertyChanged', ['Stiffness:ta:tc', [1, 0.5]]);
    return PolarSplineAreaSeries;
}(PolarLineSeriesBase));
export { PolarSplineAreaSeries };
/**
 * @hidden
 */
var PolarSplineAreaSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(PolarSplineAreaSeriesView, _super);
    function PolarSplineAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c4 = null;
        _this.da = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.c9 = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.c8 = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.c7 = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.c4 = a;
        return _this;
    }
    PolarSplineAreaSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.e.bx = 1;
        }
    };
    Object.defineProperty(PolarSplineAreaSeriesView.prototype, "db", {
        get: function () {
            return this.c9;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarSplineAreaSeriesView.prototype, "dc", {
        get: function () {
            return this.da;
        },
        enumerable: true,
        configurable: true
    });
    PolarSplineAreaSeriesView.prototype.c5 = function () {
        Extensions.e(this.c9.ak);
        Extensions.e(this.da.ak);
        Extensions.e(this.c7.ak);
        Extensions.e(this.c8.ak);
        this.aq();
    };
    PolarSplineAreaSeriesView.prototype.c6 = function (a, b) {
        this.da.ak.c = Numeric.h(a.count + 1, function (c) { return c < a.count ? a._inner[c].x : a._inner[c - a.count].x; }, function (c) { return c < a.count ? a._inner[c].y : a._inner[c - a.count].y; }, b);
        this.c9.ak.c = Numeric.h(a.count + 1, function (c) { return c < a.count ? a._inner[c].x : a._inner[c - a.count].x; }, function (c) { return c < a.count ? a._inner[c].y : a._inner[c - a.count].y; }, b);
        this.aq();
    };
    PolarSplineAreaSeriesView.prototype.bb = function () {
        _super.prototype.bb.call(this);
    };
    PolarSplineAreaSeriesView.prototype.bc = function () {
        _super.prototype.bc.call(this);
        var a = this.bo();
        this.c7.ak = this.c9.ak;
        this.c8.ak = this.da.ak;
        this.c7._fill = a;
        this.c7._opacity = 1;
        this.c8._stroke = a;
        this.c8.ac = this.e.eu + 3;
    };
    PolarSplineAreaSeriesView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.c7);
                a.s(this.c8);
            }
            else {
                a.s(this.c9);
                a.s(this.da);
            }
        }
    };
    PolarSplineAreaSeriesView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        this.e.a5.exportPathData(a, this.da, "polarShape", ["Main"]);
        this.e.a5.exportPathData(a, this.c9, "fillShape", ["Fill"]);
    };
    PolarSplineAreaSeriesView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.ni = a;
        this.e.fs = 5;
        this.e.ft = 5;
        this.e.fu = 5;
    };
    PolarSplineAreaSeriesView.$t = markType(PolarSplineAreaSeriesView, 'PolarSplineAreaSeriesView', PolarLineSeriesBaseView.$);
    return PolarSplineAreaSeriesView;
}(PolarLineSeriesBaseView));
export { PolarSplineAreaSeriesView };
//# sourceMappingURL=PolarSplineAreaSeries_combined.js.map