import { DependencyObject } from "igniteui-angular-core";
import { INotifyPropertyChanged, Base, PropertyChangedEventArgs, Type } from "igniteui-angular-core";
import { Series } from "./Series";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { LabelCollisionInfo } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CalloutAnnotation extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    k: CalloutAnnotationWrapper;
    xValue: any;
    ab: any;
    yValue: any;
    ac: any;
    text: string;
    am: string;
    aw: string;
    key: any;
    aa: any;
    content: any;
    z: any;
    series: Series;
    l: Series;
    private a0;
    private az;
    private _formatLabel;
    formatLabel: (item: any) => string;
    textColor: Brush;
    bk: Brush;
    background: Brush;
    bh: Brush;
    outline: Brush;
    bj: Brush;
    leaderBrush: Brush;
    bi: Brush;
    strokeThickness: number;
    x: number;
    o: boolean;
    private n;
    private bo;
    backgroundPadding: Thickness;
    backgroundPaddingLeft: number;
    u: number;
    backgroundPaddingTop: number;
    w: number;
    backgroundPaddingRight: number;
    v: number;
    backgroundPaddingBottom: number;
    t: number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutAnnotationWrapper extends Base {
    static $t: Type;
    private a;
    b: CalloutAnnotation;
    c: LabelCollisionInfo;
    equals(a: any): boolean;
    getHashCode(): number;
}
