import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    static $t: Type;
    constructor();
    protected get_sk(): IndicatorCalculationStrategy;
    protected readonly sk: IndicatorCalculationStrategy;
    protected get_sx(): Type;
    protected readonly sx: Type;
    s5: number;
    static readonly ta: DependencyProperty;
    protected sq(): number;
    sz(a: number): void;
    smoothingPeriod: number;
    static readonly tb: DependencyProperty;
    protected ss(): number;
    s7: number;
    static readonly tc: DependencyProperty;
    protected sp(): number;
    protected r0(): number;
}
