import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { SeriesView } from "./SeriesView";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class HighDensityScatterSeries extends Series {
    static $t: Type;
    constructor();
    protected get_dj(): boolean;
    og: NumericXAxis;
    oi: NumericYAxis;
    qc: string;
    protected on: IFastItemColumn$1<number>;
    private om;
    gt(a: any, b: string): any;
    qg: string;
    protected op: IFastItemColumn$1<number>;
    private oo;
    ow: boolean;
    ov: boolean;
    po: number;
    pn: number;
    q9: Color;
    q8: Color;
    p0: number;
    private qu;
    protected kp(a: any, b: string, c: any, d: any): void;
    ou(a: any): boolean;
    ot(a: any): boolean;
    private ql;
    private pu;
    private oq;
    private pa;
    private o9;
    private o8;
    private o7;
    private o6;
    private o5;
    private pd;
    private pc;
    private pb;
    private oe;
    private oj;
    private ok;
    private of;
    private oh;
    private os;
    ec(a: Rect, b: Rect, c: SeriesView): boolean;
    private pv;
    p1: number;
    k4(a: boolean): void;
    private qn;
    private px;
    private pr;
    private pq;
    protected jo(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    private qk;
    private qp;
    private qo;
    progressiveLoadStatusChanged: (sender: any, e: ProgressiveLoadStatusEventArgs) => void;
    private qi;
    private qm;
    private ox;
    private qw;
    private o3;
    private o2;
    private o4;
    private pg;
    private pe;
    private pf;
    private ph;
    private pj;
    private pl;
    private pk;
    private pi;
    private oz;
    private o0;
    private o1;
    private oy;
    private qr;
    dq(a: any): boolean;
    private qt;
    private py;
    private pz;
    private pm;
    private qs;
    private qq;
    private pt;
    private ps;
    private ob;
    private pw;
    private qj;
    protected bp(): SeriesView;
    kk(a: SeriesView): void;
    protected od: HighDensityScatterSeriesView;
    ao(a: Axis): AxisRange;
    private or;
    protected ln(a: Rect, b: Rect): void;
    protected lo(a: Rect, b: Rect): void;
    private _itemIndexes;
    private oc;
    private n9;
    gq(a: Point): any;
    private p2;
    qv(a: number[], b: number, c: number): void;
    protected get_d6(): boolean;
    protected set_d6(a: boolean): void;
    jl(a: boolean, b: SeriesView): void;
    k5(a: Rect, b: RenderSurface): void;
    private ol;
    k2(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ji(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class HighDensityScatterSeriesView extends SeriesView {
    static $t: Type;
    constructor(a: HighDensityScatterSeries);
    as(): void;
    ca(): void;
    protected bz: HighDensityScatterSeries;
    private bx;
    private b5;
    private b4;
    private b2;
    private b3;
    private b0;
    b6(): void;
    by(): number[];
    b9(): void;
    b8(a: () => void): void;
    protected a6(a: RenderingContext, b: boolean): void;
    b1(a: Color, b: Color): boolean;
    b7(): void;
    al(a: any): void;
}
