import { Base, Type, IEnumerable } from "igniteui-angular-core";
import { ServiceProvider_Spark } from "./ServiceProvider_Spark";
import { Dictionary$2 } from "igniteui-angular-core";
import { Message_Spark } from "./Message_Spark";
import { MessageChannel_Spark } from "./MessageChannel_Spark";
import { ViewportChangedMessage_Spark } from "./ViewportChangedMessage_Spark";
import { DomWrapper } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { BindingFormatter } from "igniteui-angular-core";
import { SparklineAxisVisualData } from "./SparklineAxisVisualData";
import { Visibility } from "igniteui-angular-core";
import { ISchedulableRender } from "igniteui-angular-core";
import { CanvasRenderScheduler } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { SparklineVisualData } from "./SparklineVisualData";
import { SparklineDisplayType } from "./SparklineDisplayType";
import { SparkFrame } from "./SparkFrame";
import { TrendLineType } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { DependencyObject } from "igniteui-angular-core";
import { IFastItemsSourceProvider } from "igniteui-angular-core";
import { IFastItemsSource } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { FastItemsSourceEventArgs } from "igniteui-angular-core";
import { PropertyChangedMessage_Spark } from "./PropertyChangedMessage_Spark";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { UnknownValuePlotting } from "igniteui-angular-core";
import { Control } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class HorizontalAxisView extends Base {
    static $t: Type;
    private j;
    w: DomWrapper;
    m: RenderingContext;
    private l;
    private s;
    v: number;
    u: number;
    private k;
    private r;
    private ag;
    private af;
    private ah;
    private a;
    private n;
    constructor(a: XamSparkline);
    private b;
    private t;
    private q;
    private g;
    h: ServiceProvider_Spark;
    private o;
    p: Dictionary$2<Type, (message: Message_Spark) => void>;
    private d;
    f: MessageChannel_Spark;
    private c;
    e: MessageChannel_Spark;
    private z;
    private aa;
    private y;
    private ae;
    private ac;
    private ad;
    x(dataItem_: any): any;
    i(): SparklineAxisVisualData;
    private ab;
}
/**
 * @hidden
 */
export declare class VerticalAxisView extends Base {
    static $t: Type;
    private ad;
    private ac;
    private al;
    private ak;
    private am;
    private w;
    private u;
    private j;
    private aa;
    private m;
    private l;
    private t;
    private v;
    z: number;
    y: number;
    private k;
    private s;
    private a;
    private n;
    constructor(a: XamSparkline);
    private b;
    private x;
    private g;
    h: ServiceProvider_Spark;
    private p;
    q: Dictionary$2<Type, (message: Message_Spark) => void>;
    private d;
    f: MessageChannel_Spark;
    private c;
    private r;
    e: MessageChannel_Spark;
    private af;
    private ag;
    private ae;
    private aj;
    private ai;
    private o;
    ab(dataItem_: any): any;
    i(): SparklineAxisVisualData;
    private ah;
}
/**
 * @hidden
 */
export declare class XamSparklineView extends Base implements ISchedulableRender {
    static $t: Type;
    private bn;
    private bm;
    private ae;
    private af;
    private ag;
    private ah;
    p: RenderingContext;
    q: RenderingContext;
    r: RenderingContext;
    private n;
    private u;
    private b;
    private y;
    constructor();
    private aw;
    private bw;
    private bu;
    private bx;
    private bv;
    private bs;
    private bt;
    private br;
    private bp;
    private bo;
    private bq;
    private j;
    k: ServiceProvider_Spark;
    private f;
    h: MessageChannel_Spark;
    private g;
    i: MessageChannel_Spark;
    private v;
    w: Dictionary$2<Type, (message: Message_Spark) => void>;
    private av;
    private a2;
    private ar;
    private l;
    readonly m: SparklineController;
    private a1;
    private a0;
    private a3;
    private a4;
    private bi;
    private bb;
    private ak;
    private ao;
    static ad(v_: string, a: number): number;
    a(a: string, b: string[]): string[];
    private s;
    private at;
    al(a: boolean): void;
    private bh;
    private aj;
    ab(a: boolean): number;
    private ac;
    private a8;
    private ba;
    private a9;
    private bl;
    private bc;
    private bk;
    private a5;
    private a7;
    private a6;
    private bj;
    private bd;
    private bg;
    private ai;
    private bf;
    private be;
    private e;
    private am;
    d: CanvasRenderScheduler;
    c: CanvasRenderScheduler;
    private t;
    private x;
    isDirty: boolean;
    private aq;
    undirty(a: boolean): void;
    readonly index: number;
    private ay;
    private ax;
    postRender(): void;
    an(a: SparklineVisualData): void;
    preRender(): void;
    isValid(): boolean;
    o(a: string): FontInfo;
    private az;
    ap(a: XamSparkline): void;
    au(): void;
    as(): void;
}
/**
 * @hidden
 */
export declare class SparkFramePreparer extends Base {
    static $t: Type;
    b: SparklineController;
    d: number;
    c: number;
    e(a: SparkFrame): void;
    private a;
    private f;
}
/**
 * @hidden
 */
export declare class SparklineConnector extends Base {
    static $t: Type;
    d: XamSparkline;
    b: SparklineController;
    e: XamSparklineView;
    a: HorizontalAxisView;
    c: VerticalAxisView;
    constructor(a: DependencyObject, b: XamSparklineView);
}
/**
 * @hidden
 */
export declare class SparklineController extends DependencyObject implements IFastItemsSourceProvider {
    static $t: Type;
    constructor(a: ServiceProvider_Spark);
    k: MessageChannel_Spark;
    m: MessageChannel_Spark;
    l: MessageChannel_Spark;
    private p;
    q: XamSparkline;
    r: XamSparklineView;
    readonly x: IEnumerable;
    static readonly a2: DependencyProperty;
    u: IFastItemsSource;
    t: IFastItemColumn$1<number>;
    s: IFastItemColumn$1<any>;
    o: SparkFramePreparer;
    n: SparkFrame;
    readonly ad: string;
    readonly ac: string;
    a3: Rect;
    protected readonly ab: any;
    aa: (sender: any, e: FastItemsSourceEventArgs) => void;
    y(a: number): number;
    z(a: number): number;
    protected w(): boolean;
    private v;
    private av;
    private ay;
    private a0;
    private ax;
    private au;
    private an;
    private aw;
    ah(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    private az;
    ag(a: Message_Spark): void;
    private ai;
    aj(a: Message_Spark): void;
    am(a: PropertyChangedMessage_Spark): void;
    private at;
    a1(a: ViewportChangedMessage_Spark): void;
    private al;
    private ak;
    private af;
    private ae;
    protected ao(): void;
    private ap;
    private as;
    private ar;
    private j;
    private aq;
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
}
/**
 * @hidden
 */
export declare class XamSparkline extends Control {
    static $t: Type;
    constructor();
    private ap;
    e8: Brush;
    ff: Brush;
    fe: Brush;
    fg: Brush;
    e9: Brush;
    fc: Brush;
    fa: Brush;
    fd: Brush;
    fi: Brush;
    fb: Brush;
    fj: Brush;
    fh: Brush;
    fm: Visibility;
    ft: Visibility;
    fp: Visibility;
    fq: Visibility;
    fk: Visibility;
    fn: Visibility;
    fo: Visibility;
    fl: Visibility;
    fr: Visibility;
    aw: boolean;
    static readonly bf: number;
    bd: number;
    a6: number;
    a8: number;
    a7: number;
    bc: number;
    bi: number;
    static readonly bb: number;
    a9: number;
    bh: number;
    bg: number;
    itemsSource: IEnumerable;
    c9: string;
    ce: string;
    static readonly ev: DependencyProperty;
    toolTip: any;
    fs: Visibility;
    ar: TrendLineType;
    bq: number;
    static readonly bo: number;
    bm: number;
    bk: number;
    bj: number;
    aq: SparklineDisplayType;
    as: UnknownValuePlotting;
    bt: any;
    br: any;
    ax(): boolean;
    c1(a: any): string;
    bp: (arg1: any) => string;
    ca: string;
    ag: any[];
    ai: BindingFormatter;
    df: string;
    ah: any[];
    aj: BindingFormatter;
    private an;
    ao: ServiceProvider_Spark;
    private al;
    am: MessageChannel_Spark;
    private a0;
    a4: number;
    private az;
    a3: number;
    av: IFastItemColumn$1<any>;
    ak: HorizontalAxisView;
    at: VerticalAxisView;
    ds(a: ServiceProvider_Spark, b: ServiceProvider_Spark): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    protected dr(a: string, b: any, c: any): void;
    destroy(): void;
    provideContainer(a: any): void;
    notifyResized(): void;
    dn(source_: any, a: number, b: any, c: any): void;
    dj(source_: any): void;
    dk(source_: any, a: number, b: any): void;
    dl(source_: any, a: number, b: any): void;
    au(): SparklineVisualData;
    by(): string;
    private a2;
    bl: number;
    private a1;
    a5: number;
    static $$p: string[];
}
