import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point, Type } from "igniteui-angular-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { ScalerParams } from "./ScalerParams";
/**
 * @hidden
 */
export declare abstract class HorizontalRangeCategorySeries extends RangeCategorySeries {
    static $t: Type;
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ji(): void;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected get_di(): boolean;
    protected bj(): SeriesHitTestMode;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    gd(a: Point, b: boolean): number;
    gf(a: Point, b: boolean): number;
    e2(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    fh(a: Point, b: boolean, c: boolean): number;
    ff(a: Point, b: boolean, c: boolean): number;
    fd(a: Point, b: boolean, c: boolean): number;
    np(a: Point, b: boolean, c: boolean): Point;
    nr(a: Point, b: boolean, c: boolean): Point;
    nt(a: Point, b: boolean, c: boolean): Point;
    qo(): boolean;
    protected kp(a: any, b: string, c: any, d: any): void;
    r2(a: any): boolean;
    r1(a: any): boolean;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
