import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { Style } from "igniteui-angular-core";
import { MarkerType } from "./MarkerType";
import { DataTemplate } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { Rect } from "igniteui-angular-core";
import { Type, Point } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { DataContext } from "igniteui-angular-core";
import { IDictionary$2 } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { FrameworkElement } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { Size } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ScatterPolygonSeries extends ShapeSeriesBase {
    static $t: Type;
    constructor();
    protected pi(): boolean;
    protected qh(a: SeriesView): void;
    ru(a: ScatterPolygonSeriesView): void;
    private rd;
    protected bp(): SeriesView;
    kk(a: SeriesView): void;
    ra: ScatterPolygonSeriesView;
    rb: ShapeAxisInfoCache;
    private static sg;
    private q8;
    private q9;
    protected get_hasMarkers(): boolean;
    ne(): Brush;
    nf(): Brush;
    lu(): DataTemplate;
    rc: StyleSelector;
    si: Style;
    q7: MarkerType;
    rx: DataTemplate;
    rf: number;
    fc(): number;
    rw: DataTemplate;
    se: Brush;
    sc: Brush;
    sf: Brush;
    sd: Brush;
    sh: Style;
    qy: CollisionAvoidanceType;
    private q3;
    q4: MarkerOutlineMode;
    q6(): MarkerOutlineMode;
    lj(a: MarkerOutlineMode): void;
    q5: MarkerOutlineMode;
    private qz;
    q0: MarkerFillMode;
    q2(): MarkerFillMode;
    li(a: MarkerFillMode): void;
    q1: MarkerFillMode;
    protected lg(): void;
    protected kf(): void;
    protected kp(a: any, b: string, c: any, d: any): void;
    as(a: Point, b: boolean): DataContext;
    rv(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    ct(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    qx(a: ScatterPolygonSeriesView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    re(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
    static $t: Type;
    constructor(a: ScatterPolygonSeries);
    as(): void;
    readonly dd: NumericMarkerManager;
    dh: boolean;
    protected dw(a: IDictionary$2<any, OwnedPoint>): void;
    protected c7(): Point[];
    protected di(): List$1<number>;
    private c8;
    private dj;
    private de;
    private dc;
    protected c2(a: number, b: List$1<PointCollection>): PathGeometry;
    cj(a: FrameworkElement, b: any, c: boolean): void;
    protected ch(a: FrameworkElement, b: PathGeometry): void;
    private dg;
    df: HashPool$2<any, Marker>;
    dq(a: (arg1: Marker) => void): void;
    ds(a: HashPool$2<any, Marker>): void;
    db(): Marker;
    protected dk: List$1<Marker>;
    b1(a: Point): Marker;
    private da;
    du(a: Marker): void;
    dt(a: Marker): void;
    dv(a: Marker): void;
    dx(a: boolean): void;
    protected bh(a: any, b: number): void;
    private c9;
    protected bi(a: any, b: number): void;
    protected a5(a: RenderingContext, b: boolean): void;
    dp(): void;
    dm(): void;
    dn(): void;
    dl(a: string): void;
    dr(): void;
    private dy;
    dz(a: Marker): Size;
    al(a: any): void;
    getDefaultTooltipTemplate(): string;
}
