import { StackedColumnSeries } from "./StackedColumnSeries";
import { IStacked100Series } from "./IStacked100Series";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { CategorySeriesView } from "./CategorySeriesView";
import { StackedColumnSeriesView } from "./StackedColumnSeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
/**
 * @hidden
 */
export declare class Stacked100ColumnSeries extends StackedColumnSeries implements IStacked100Series {
    static $t: Type;
    protected get_ru(): boolean;
    constructor();
    ac(): void;
    protected bp(): SeriesView;
    sy: Stacked100ColumnSeriesView;
    kk(a: SeriesView): void;
    rm(): CategorySeriesView;
    protected sa(): void;
    readonly useHighMarkerFidelity: boolean;
}
/**
 * @hidden
 */
export declare class Stacked100ColumnSeriesView extends StackedColumnSeriesView {
    static $t: Type;
    c5: Stacked100ColumnSeries;
    constructor(a: Stacked100ColumnSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
