import { IgxAssigningSeriesStyleEventArgsBase } from "./igx-assigning-series-style-event-args-base";
import { AssigningSeriesShapeStyleEventArgsBase as AssigningSeriesShapeStyleEventArgsBase_internal } from "./AssigningSeriesShapeStyleEventArgsBase";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*/
export declare abstract class IgxAssigningSeriesShapeStyleEventArgsBase extends IgxAssigningSeriesStyleEventArgsBase {
    /**
                                 * @hidden
                                 */
    readonly i: AssigningSeriesShapeStyleEventArgsBase_internal;
    constructor();
    /**
     * Gets or sets stroke thickness to use for the current item.
    */
    strokeThickness: number;
    /**
     * Gets or sets corner radius X to use for the current item, if applicable.
    */
    radiusX: number;
    /**
     * Gets or sets corner radius Y to use for the current item, if applicable.
    */
    radiusY: number;
}
