import { Type } from '@angular/core';
import { IgxStackedColumnSeriesComponent } from "./igx-stacked-column-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { Stacked100ColumnSeries } from "./Stacked100ColumnSeries";
/**
 * Represents a IgxDataChartComponent stacked100 column series.
*/
export declare const IgxStacked100ColumnSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxStacked100ColumnSeriesComponent extends IgxStackedColumnSeriesComponent {
    protected createImplementation(): Stacked100ColumnSeries;
    /**
                                 * @hidden
                                 */
    readonly i: Stacked100ColumnSeries;
    constructor();
    readonly isPercentBased: boolean;
}
