/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Boolean_$type, typeCast, markType, Point_$type, typeGetValue, fromEnum, runOn, Number_$type, markDep } from "igniteui-angular-core";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-angular-core";
import { Extensions } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core";
import { LabelPosition } from "./LabelPosition";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler_$type } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-angular-core";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { AxisLabelManager } from "./AxisLabelManager";
import { ViewportUtils } from "./ViewportUtils";
import { RadialAxisRenderingParameters } from "./RadialAxisRenderingParameters";
import { CategoryTickmarkValues } from "./CategoryTickmarkValues";
import { MathUtil } from "igniteui-angular-core";
import { SeriesViewer } from "./SeriesViewer";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { LineGeometry } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { RangeInfo } from "./RangeInfo";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { LogarithmicTickmarkValues } from "./LogarithmicTickmarkValues";
import { PolarAxisRenderingParameters } from "./PolarAxisRenderingParameters";
import { RadialAxisLabelPanel } from "./RadialAxisLabelPanel";
import { LinearTickmarkValues } from "./LinearTickmarkValues";
import { IPolarRadialRenderingParameters_$type } from "./IPolarRadialRenderingParameters";
import { PathGeometry } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { ArcSegment } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
export class AngleAxisLabelPanel extends AxisLabelPanelBase {
    constructor() {
        super();
        this.cu = false;
        this.c0 = null;
        this.cy = 0;
        this.cv = 0;
        this.cx = 0;
        this.cw = 0;
    }
    ad() {
        return new AngleAxisLabelPanelView(this);
    }
    b9(a) {
        super.b9(a);
        this.ct = a;
    }
    ap(a, b) {
        if (!Extensions.b(b)) {
            return false;
        }
        if (this.ac == null || this.ac.ja.isEmpty) {
            return super.ap(a, b);
        }
        return true;
    }
    az() {
        let a = new List$1(Rect.$, 0);
        let b = new List$1(Boolean_$type, 0);
        if (this.a4.count != this.a3.count) {
            return a;
        }
        this.ct.ay(a, b);
        let c = false;
        this.an = this.am(a, b);
        if (!this.ac.b1()) {
            c = true;
            this.ba = this.cy / 2;
            this.ba = this.ba + this.cz();
        }
        else {
            c = true;
            this.ct.ac();
        }
        if (c) {
            for (let d = 0; d < a.count; d++) {
                let e = this.a4._inner[d];
                let f = this.a3._inner[d];
                let g = a._inner[d];
                let h = this.c0(f.c);
                let i = h.x - this.bd(e) / 2;
                let j = h.y - this.bc(e) / 2;
                g.x = i;
                g.y = j;
                a._inner[d] = g;
            }
        }
        return a;
    }
    cz() {
        let a;
        let b;
        b = this.ac;
        a = null;
        if (b != null) {
            a = typeCast(XamDataChart.$, b.bh);
        }
        if (a == null || b == null) {
            return 0;
        }
        let c = new List$1(Axis.$, 0);
        for (let d = 0; d < a.axes.count; d++) {
            let e = a.axes._inner[d];
            if ((typeCast(NumericAngleAxis.$, e) !== null || typeCast(CategoryAngleAxis.$, e) !== null) && typeCast(AngleAxisLabelPanel.$, e.av) !== null && e.av.a4.count > 0 && (!e.b1()) && !e.b0() && (e.ai == null || this.ac.ai == null || e.ai.ls == b.ai.ls)) {
                c.add(e);
            }
        }
        let f = c.indexOf(b);
        if (f == -1) {
            return 0;
        }
        let g = 0;
        let h = 5;
        if (f == 0) {
            g += h;
        }
        else {
            g += c._inner[f - 1].av.ba;
            g += c._inner[f].av.ba * 2 + h;
        }
        return g;
    }
    ah() {
        return 4;
    }
    at(a) {
        return a == 4 || a == 5;
    }
}
AngleAxisLabelPanel.$t = markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
/**
 * @hidden
 */
export class CategoryAngleAxis extends CategoryAxisBase {
    constructor() {
        super();
        this.lb = null;
        this.k8 = null;
        this.lc = false;
        this.lg = NaN;
        this.k9 = null;
        this.lh = 0;
        this.le = 0;
        this.lf = 0;
        this.ls = 1;
        this.ab = CategoryAngleAxis.$;
        this.k8 = this.k7();
        this.lb = new PolarAxisRenderingManager();
    }
    a3() {
        return new CategoryAngleAxisView(this);
    }
    gy(a) {
        super.gy(a);
        this.k6 = a;
    }
    get_b2() {
        return true;
    }
    au() {
        let a = new AngleAxisLabelPanel();
        a.c0 = (b) => {
            let c = this.bh != null ? this.bh.os : Rect.empty;
            let d = !c.isEmpty ? this.ja : Rect.empty;
            return this.l5(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.av.ba);
        };
        return a;
    }
    lq(a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    }
    k7() {
        let a = ((() => {
            let $ret = new AxisLabelManager();
            $ret.a = this;
            $ret.f = this.cy;
            $ret.e = this.cx;
            $ret.b = this.av;
            return $ret;
        })());
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        let b = new CategoryAxisRenderer(a);
        b.u = () => {
            let c = this.a4.ay();
            let d = this.a4.a1();
            let e = this.a4.az();
            let f = this.a4.a0();
            this.hl();
            this.go(c);
            this.go(d);
            this.go(e);
            this.go(f);
        };
        b.o = (c, d) => !d.isEmpty && !c.isEmpty && this.la != null;
        b.d = (c, d, e, f) => this.k5(c, d, e, f);
        b.v = () => {
            if (!this.lc) {
                this.lc = true;
                this.la.cn();
                this.lc = false;
            }
        };
        b.g = (c) => {
            let d = typeGetValue(c);
            if (d > this.jo.count - 1) {
                d -= this.jo.count;
            }
            let e = this.jo.item(d);
            return this.e9(e);
        };
        b.b.c = (c) => {
            if ((this.ay == null || this.ay.visibility == 0) && this.la != null && this.lg != c) {
                let d = typeCast(XamDataChart.$, this.bh);
                if (d == null) {
                    return;
                }
                this.lg = c;
                this.av.a9 = c;
                d.ja();
                for (let e of fromEnum(d.axes)) {
                    if (e != this && typeCast(AngleAxisLabelPanel.$, e.av) !== null) {
                        e.a4.ad();
                    }
                }
            }
        };
        b.k = (c, d, e) => {
            let f = typeCast(RadialAxisRenderingParameters.$, c);
            this.lb.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
        };
        b.l = (c, d, e, f) => {
            let g = typeCast(RadialAxisRenderingParameters.$, c);
            this.lb.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
        };
        b.m = (c, d) => this.getScaledAngle(d);
        b.q = (c, d) => {
            if (this.lq(d - this.lh) < 0) {
                return false;
            }
            if (this.lq(d - this.lh - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        b.j = (c) => {
            let d = typeCast(RadialAxisRenderingParameters.$, c);
            if (d.e == d.k._inner[0]) {
                this.lb.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
            }
        };
        b.e = (c) => {
            c.n = this.lk();
            c.r = c.n;
        };
        b.p = (c, d, e) => {
            let f = typeCast(RadialAxisRenderingParameters.$, c);
            if (e) {
                return false;
            }
            let g = this.l5(d, f.center, c.aa, c.z, 0);
            if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                return true;
            }
            return false;
        };
        b.a = (c, d, e, f) => {
            let g = c.y;
            let h = new ScalerParams(0, c.aa, c.z, this.ca, g);
            let i = d;
            if (this.categoryMode != 0) {
                let j = (e * f) + 1;
                j = Math.min(j, this.j8);
                let k = this.dz(j, h);
                i = (d + k) / 2;
            }
            return i;
        };
        b.f = runOn(this, this.getGroupCenter);
        b.i = runOn(this, this.ln);
        return b;
    }
    l5(a, b, c, d, e) {
        let f = this.lk();
        let g = ViewportUtils.b(e, c, d);
        if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
            g *= -1;
        }
        let h = b.x + (f + g) * Math.cos(a);
        let i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    }
    lk() {
        if (this.la == null) {
            return 0;
        }
        if (!this.b0()) {
            return this.la.lx();
        }
        else {
            return this.la.ly((this.e5));
        }
    }
    k5(a, b, c, d) {
        if (this.jo == null) {
            return null;
        }
        let e = new RadialAxisRenderingParameters();
        let f = this.jo.count - 1;
        let g = this.a4.ay();
        let h = this.a4.a1();
        let i = this.a4.az();
        let j = this.a4.a0();
        e.t = g;
        e.w = h;
        e.u = i;
        e.v = j;
        e.l = f;
        e.m = 0;
        e.h = false;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.g = this.ld();
        e.p = this.lo;
        e.o = this.ec();
        e.q = this.lp;
        e.s = this.fa;
        let k = this.lb.f(b);
        let l = this.lb.g(b);
        let m = 0.5 * this.la.ls;
        let n = 0.5 * this.la.lr;
        let o = k;
        let p = l;
        let q = this.la.lx();
        if (isNaN_(q) || isInfinity(q)) {
            return null;
        }
        if (p >= m) {
            p = q;
        }
        if (o < n) {
            o = n;
        }
        let r = a.width;
        this.lb.k(b, e, 0, this.jo.count, this.ca, runOn(this, this.getUnscaledAngle), r);
        let s = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = s;
        e.maxLength = p;
        e.minLength = o;
        e.effectiveMaximum = q;
        e.ae = this.jo.count;
        e.ab = this.categoryMode;
        e.ad = true;
        e.ac = this.ca;
        e.af = this.ka;
        e.f = new CategoryTickmarkValues();
        e.j = this.cl;
        return e;
    }
    getMinMaxAngle(a, b, c) {
        let d = this.lb.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    }
    ac() {
        super.ac();
        this.hc(false);
    }
    get la() {
        if (this.k9 != null) {
            return this.k9;
        }
        let a = typeCast(XamDataChart.$, this.bh);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.k9;
    }
    set la(a) {
        this.k9 = a;
    }
    aj() {
        return this.la;
    }
    getCategorySize(a, b, c) {
        return 2 * Math.PI / this.j8;
    }
    j0(a, b, c) {
        let d = !isNaN_(this.jx) ? MathUtil.b(this.jx, 0, 1) : 0;
        let e = 0;
        if (!isNaN_(this.j4)) {
            e = Math.min(this.j4, 1);
        }
        let f = 1 - 0.5 * d;
        return this.getCategorySize(a, b, c) * f / (this.ka - (this.ka - 1) * e);
    }
    getGroupCenter(a, b, c, d) {
        let e = 0.5;
        if (this.ka > 1) {
            let f = !isNaN_(this.jx) ? MathUtil.b(this.jx, 0, 1) : 0;
            let g = 0;
            if (!isNaN_(this.j4)) {
                g = Math.min(this.j4, 1);
            }
            let h = 1 - 0.5 * f;
            let i = h / (this.ka - (this.ka - 1) * g);
            let j = (h - i) / (this.ka - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    }
    ln(a) {
        let b = 0.5;
        if (this.ka > 1) {
            let c = !isNaN_(this.jx) ? MathUtil.b(this.jx, 0, 1) : 0;
            let d = 0;
            if (!isNaN_(this.j4)) {
                d = Math.min(this.j4, 1);
            }
            let e = 1 - 0.5 * c;
            let f = e / (this.ka - (this.ka - 1) * d);
            let g = (e - f) / (this.ka - 1);
            b = 0.25 * c + 0.5 * f + a * g;
        }
        return b;
    }
    hd(a) {
        super.hd(a);
        let b = this.bh != null ? this.bh.os : Rect.empty;
        let c = !b.isEmpty ? this.ja : Rect.empty;
        let d = this.i5();
        let e = this.i4();
        let f = this.k8.c(a, c, b, d, e);
        if (f != null) {
            this.li = f.f.m;
            this.lj = f.f.l;
        }
    }
    lm(a, b) {
        let c;
        let d;
        let e = this.lb.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (c == 0) {
            if (this.ca) {
                return this.j8;
            }
            else {
                return 0;
            }
        }
        let f = this.getUnscaledAngle(c);
        if (f < 0 || f > this.j8) {
            f = this.getUnscaledAngle(c + Math.PI * 2);
        }
        return f;
    }
    ll(a, b) {
        let c;
        let d;
        let e = this.lb.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (d > Math.PI * 2) {
            d = d - Math.PI * 2;
        }
        if (d == Math.PI * 2) {
            if (this.ca) {
                return 0;
            }
            else {
                return this.j8;
            }
        }
        let f = this.getUnscaledAngle(d);
        if (f < 0 || f > this.j8) {
            f = this.getUnscaledAngle(d + Math.PI * 2);
        }
        return f;
    }
    getScaledAngle(a) {
        let b = this.j8;
        let c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
        if (this.cb) {
            c = 1 - c;
        }
        return (c * 2 * Math.PI) + this.lh;
    }
    getUnscaledAngle(a) {
        if (a < this.lh) {
            a += 2 * Math.PI;
        }
        let b = (a - this.lh) / (2 * Math.PI);
        if (this.ca) {
            b = 1 - b;
        }
        return b * (this.j8);
    }
    dz(a, b) {
        return this.getScaledAngle(a);
    }
    d2(a, b) {
        return this.getUnscaledAngle(a);
    }
    g0(a, b, c, d) {
        super.g0(a, b, c, d);
        let e = typeCast(XamDataChart.$, this.bh);
        switch (b) {
            case "CrossingAxis":
                let f = typeCast(NumericRadiusAxis.$, d);
                this.l1(f);
                if (f != null) {
                    f.l7(this);
                }
                this.ci = true;
                this.hc(false);
                break;
            case CategoryAngleAxis.$$p[0]:
                this.lh = this.lr;
                while (this.lh < 0) {
                    this.lh += 360;
                }
                while (this.lh >= 360) {
                    this.lh -= 360;
                }
                this.lh = (this.lh * Math.PI) / 180;
                this.ci = true;
                this.hc(false);
                for (let g of fromEnum(this.cz)) {
                    g.k3(false);
                    g.ka();
                }
                break;
            case "Label":
                if (e != null) {
                    for (let h of fromEnum(e.axes)) {
                        h.ci = true;
                        h.hb();
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    for (let i of fromEnum(e.axes)) {
                        if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                            i.ci = true;
                            i.hb();
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.k8 = this.k7();
                this.lz();
                this.ci = true;
                this.hc(false);
                break;
        }
    }
    lz() {
        this.lg = NaN;
    }
    l1(a) {
        this.la = a;
    }
    get lo() {
        return this.c(CategoryAngleAxis.l2);
    }
    set lo(a) {
        this.h(CategoryAngleAxis.l2, a);
    }
    get li() {
        return this.le;
    }
    set li(a) {
        if (this.li != a) {
            let b = this.le;
            this.le = a;
            this.g6("ActualInterval", b, this.li);
        }
    }
    ea() {
        return this.li;
    }
    get lp() {
        return this.c(CategoryAngleAxis.l3);
    }
    set lp(a) {
        this.h(CategoryAngleAxis.l3, a);
    }
    get lj() {
        return this.lf;
    }
    set lj(a) {
        if (this.lj != a) {
            let b = this.lf;
            this.lf = a;
            this.g6("ActualMinorInterval", b, this.lj);
        }
    }
    ld() {
        return false;
    }
    get_a1() {
        return 2;
    }
    get a1() {
        return this.get_a1();
    }
    cp() {
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        if (this.jo == null) {
            return false;
        }
        let a = this.jo.count;
        if (a != this.lt) {
            let b = new AxisRangeChangedEventArgs(0, 1, 1, this.lt, a);
            this.lt = a;
            this.g7(b);
            return true;
        }
        return false;
    }
    get lt() {
        return this.ls;
    }
    set lt(a) {
        this.ls = a;
    }
    i2(a, b, c, d = null, e = null) {
        let f = typeCast(RadialAxisRenderingParameters.$, this.k8.d(c, b, d, e));
        if (f == null) {
            return null;
        }
        let g = Math.cos(a);
        let h = Math.sin(a);
        let i = f.center.x + g * f.minLength;
        let j = f.center.y + h * f.minLength;
        let k = f.center.x + g * f.maxLength;
        let l = f.center.y + h * f.maxLength;
        i = ViewportUtils.c(i, b, c);
        j = ViewportUtils.f(j, b, c);
        k = ViewportUtils.c(k, b, c);
        l = ViewportUtils.f(l, b, c);
        let m = new LineGeometry();
        m.d = { $type: Point_$type, x: i, y: j };
        m.c = { $type: Point_$type, x: k, y: l };
        return m;
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d2.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dz.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gs.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gu.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
CategoryAngleAxis.$t = markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
CategoryAngleAxis.l2 = DependencyProperty.i("Interval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    a.g6("Interval", b.oldValue, b.newValue);
    a.hc(false);
}));
CategoryAngleAxis.l3 = DependencyProperty.i("MinorInterval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    (typeCast(CategoryAngleAxis.$, a)).g6("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryAngleAxis.$, a)).hc(false);
}));
CategoryAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryAngleAxis, 'g6', ['StartAngleOffset:lr:l4', [1, 0]]);
/**
 * @hidden
 */
export class NumericAngleAxis extends NumericAxisBase {
    constructor() {
        super();
        this.lo = null;
        this.lp = false;
        this.lq = NaN;
        this.lr = 0;
        this.lm = null;
        this.ab = NumericAngleAxis.$;
        this.lo = new PolarAxisRenderingManager();
        this.jo = this.jm();
    }
    a3() {
        return new NumericAngleAxisView(this);
    }
    gy(a) {
        super.gy(a);
        this.ll = a;
    }
    get_b2() {
        return true;
    }
    au() {
        let a = new AngleAxisLabelPanel();
        a.c0 = (b) => {
            let c = this.bh != null ? this.bh.os : Rect.empty;
            let d = !c.isEmpty ? this.ja : Rect.empty;
            return this.l1(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.av.ba);
        };
        return a;
    }
    ls() {
        if (this.ln == null) {
            return 0;
        }
        if (!this.b0()) {
            return this.ln.lx();
        }
        else {
            return this.ln.ly((this.e5));
        }
    }
    lu(a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    }
    jm() {
        let a = super.jm();
        a.b.c = (b) => {
            if ((this.ay == null || this.ay.visibility == 0) && this.ln != null && this.lq != b) {
                let c = typeCast(XamDataChart.$, this.bh);
                if (c == null) {
                    return;
                }
                this.lq = b;
                this.av.a9 = b;
                c.ja();
                for (let d of fromEnum(c.axes)) {
                    if (d != this && typeCast(AngleAxisLabelPanel.$, d.av) !== null) {
                        d.a4.ad();
                    }
                }
            }
        };
        a.e = (b) => {
            b.n = this.ls();
            b.r = b.n;
        };
        a.j = (b) => {
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            if (c.e == c.k._inner[0]) {
                this.lo.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
            }
        };
        a.k = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            this.lo.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
        };
        a.l = (b, c, d, e) => {
            let f = typeCast(PolarAxisRenderingParameters.$, b);
            this.lo.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
        };
        a.d = (b, c, d, e) => {
            let f = typeCast(PolarAxisRenderingParameters.$, this.jp(b, c, d, e));
            return f;
        };
        a.v = () => {
            if (!this.lp) {
                this.lp = true;
                this.ln.cn();
                this.lp = false;
            }
        };
        a.m = (b, c) => this.getScaledAngle(c);
        a.o = (b, c) => !c.isEmpty && !b.isEmpty && this.ln != null;
        a.q = (b, c) => {
            if (this.lu(c - this.lr) < 0) {
                return false;
            }
            if (this.lu(c - this.lr - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        a.p = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            let f = this.l1(this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
            let g = this.l1(c, e.center, b.aa, b.z, 0);
            if (d && MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                return false;
            }
            if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                return true;
            }
            return false;
        };
        a.r = (b, c, d, e) => {
            if (c < b.m && typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                return b.m;
            }
            else if (c > b.l && (typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                return b.l;
            }
            return c;
        };
        return a;
    }
    l1(a, b, c, d, e) {
        let f = this.ls();
        let g = ViewportUtils.b(e, c, d);
        if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
            g *= -1;
        }
        let h = b.x + (f + g) * Math.cos(a);
        let i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    }
    dz(a, b) {
        return this.getScaledAngle(a);
    }
    getScaledAngle1(a, b, c) {
        let d = 0;
        if (b) {
            d = (Math.log(a) - this.kj) / (this.ki - this.kj);
        }
        else {
            d = (a - this.kd) / (this.kc - this.kd);
        }
        if (c) {
            d = 1 - d;
        }
        return (d * 2 * Math.PI) + this.lr;
    }
    getScaledAngle(a) {
        return this.getScaledAngle1(a, this.j3, this.cb);
    }
    d2(a, b) {
        return this.getUnscaledAngle(a);
    }
    getUnscaledAngle(a) {
        let b = (a - this.lr) / (2 * Math.PI);
        if (this.ca) {
            b = 1 - b;
        }
        if (this.j3) {
            return Math.exp(b * (this.ki - this.kj) + this.kj);
        }
        else {
            return this.kd + b * (this.kc - this.kd);
        }
    }
    g0(a, b, c, d) {
        super.g0(a, b, c, d);
        let e = typeCast(XamDataChart.$, this.bh);
        switch (b) {
            case "CrossingAxis":
                let f = typeCast(NumericRadiusAxis.$, d);
                this.lz(f);
                if (f != null) {
                    f.l7(this);
                }
                this.hc(false);
                break;
            case NumericAngleAxis.$$p[0]:
                this.lr = this.lv;
                while (this.lr < 0) {
                    this.lr += 360;
                }
                while (this.lr >= 360) {
                    this.lr -= 360;
                }
                this.lr = (this.lv * Math.PI) / 180;
                this.hc(false);
                for (let g of fromEnum(this.cw())) {
                    g.k3(false);
                    g.ka();
                }
                break;
            case "Label":
                if (e != null) {
                    for (let h of fromEnum(e.axes)) {
                        h.hb();
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    for (let i of fromEnum(e.axes)) {
                        if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                            i.hb();
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.jo = this.jm();
                this.lx();
                this.ci = true;
                this.hc(false);
                break;
        }
    }
    lx() {
        this.lq = NaN;
    }
    jq() {
        return new PolarAxisRenderingParameters();
    }
    jp(a, b, c, d) {
        let e = typeCast(PolarAxisRenderingParameters.$, super.jp(a, b, c, d));
        let f = this.lo.f(b);
        let g = this.lo.g(b);
        let h = 0.5 * this.ln.ls;
        let i = 0.5 * this.ln.lr;
        let j = f;
        let k = g;
        let l = this.ln.lx();
        if (isNaN_(l) || isInfinity(l)) {
            return null;
        }
        if (k >= h) {
            k = l;
        }
        if (j < i) {
            j = i;
        }
        let m = a.width;
        this.lo.k(b, e, this.kd, this.kc, this.ca, runOn(this, this.getUnscaledAngle), m);
        let n = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = n;
        e.maxLength = k;
        e.minLength = j;
        e.effectiveMaximum = l;
        return e;
    }
    getMinMaxAngle(a, b, c) {
        let d = this.lo.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    }
    hd(a) {
        super.hd(a);
        let b = this.bh != null ? this.bh.os : Rect.empty;
        let c = !b.isEmpty ? this.ja : Rect.empty;
        let d = this.i5();
        let e = this.i4();
        let f = this.jo.c(a, c, b, d, e);
        if (f != null) {
            this.kb = f.f.m;
            this.ke = f.f.l;
        }
    }
    get ln() {
        if (this.lm != null) {
            return this.lm;
        }
        let a = typeCast(XamDataChart.$, this.bh);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (a.axes._inner[b].ce) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.lm;
    }
    set ln(a) {
        this.lm = a;
    }
    aj() {
        return this.ln;
    }
    lz(a) {
        this.ln = a;
    }
    ho(a, b) {
        super.ho(a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cn();
        }
    }
    get_a1() {
        return 2;
    }
    get a1() {
        return this.get_a1();
    }
    i2(a, b, c, d = null, e = null) {
        if (this.ln == null) {
            return null;
        }
        let f = typeCast(PolarAxisRenderingParameters.$, this.jp(c, b, d, e));
        if (f == null) {
            return null;
        }
        let g = Math.cos(a);
        let h = Math.sin(a);
        let i = f.center.x + g * f.minLength;
        let j = f.center.y + h * f.minLength;
        let k = f.center.x + g * f.maxLength;
        let l = f.center.y + h * f.maxLength;
        i = ViewportUtils.c(i, b, c);
        j = ViewportUtils.f(j, b, c);
        k = ViewportUtils.c(k, b, c);
        l = ViewportUtils.f(l, b, c);
        let m = new LineGeometry();
        m.d = { $type: Point_$type, x: i, y: j };
        m.c = { $type: Point_$type, x: k, y: l };
        return m;
    }
}
NumericAngleAxis.$t = markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
NumericAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericAngleAxis, 'g6', ['StartAngleOffset:lv:l0', [1, 0]]);
/**
 * @hidden
 */
export class NumericRadiusAxis extends NumericAxisBase {
    constructor() {
        super();
        this.lo = null;
        this.lp = false;
        this.lq = NaN;
        this.ls = 0;
        this.lr = 0;
        this.lu = 0;
        this.ll = null;
        this.ab = NumericRadiusAxis.$;
        this.ls = this.l2;
        this.lr = this.l1;
        this.lo = new PolarAxisRenderingManager();
        this.jo = this.jm();
    }
    a3() {
        return new NumericRadiusAxisView(this);
    }
    gy(a) {
        super.gy(a);
        this.ln = a;
    }
    get_ce() {
        return true;
    }
    dy() {
        let a = this.ls;
        let b = this.lr;
        let c = Math.min(this.lw(), this.lv()) * (a - b) / 2;
        c = Math.max(c, 14);
        return c;
    }
    lw() {
        return this.ja.width;
    }
    lv() {
        return this.ja.height;
    }
    au() {
        return new RadialAxisLabelPanel();
    }
    lt(a) {
        if (a == null) {
            return 0;
        }
        return a;
    }
    jm() {
        let a = super.jm();
        a.b.c = (b) => {
            if ((this.ay == null || this.ay.visibility == 0) && this.lm != null) {
                if ((this.ay == null || (this.ay.c == 4 || this.ay.c == 5)) && this.lq != b) {
                    this.lq = b;
                    this.av.a9 = b;
                    this.bh.ja();
                }
            }
        };
        a.k = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            this.lo.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
        };
        a.l = (b, c, d, e) => {
            if (d == e) {
                return;
            }
            let f = typeCast(PolarAxisRenderingParameters.$, b);
            this.lo.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
        };
        a.m = (b, c) => this.ly(c);
        a.q = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.n = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.j = (b) => {
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            this.lo.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
        };
        a.e = (b) => {
            b.n = this.ay == null || (this.ay.c == 4 || this.ay.c == 0) ? b.z.top : b.z.bottom;
            b.r = b.n;
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            c.crossingAngleRadians = (this.lt(this.e5) * Math.PI) / 180;
            if (this.ay == null || (this.ay.c == 4 || this.ay.c == 5)) {
                c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                c.r = c.n;
                let d = typeCast(RadialAxisLabelPanel.$, this.av);
                if (d != null) {
                    let e = 0;
                    if (this.ay != null && this.ay.c == 4) {
                        e = 1;
                    }
                    d.dh = { $type: Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                    d.de = c.crossingAngleRadians;
                }
            }
        };
        a.p = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            if (this.lm == null) {
                return false;
            }
            if (c > e.effectiveMaximum) {
                return false;
            }
            let f = false;
            f = this.ay == null || (this.ay.c == 4 || this.ay.c == 5);
            let g = 0;
            if (f) {
                g = this.lu;
            }
            let h = e.center.x + c * Math.cos(g);
            let i = e.center.y + c * Math.sin(g);
            h = ViewportUtils.c(h, e.aa, e.z);
            i = ViewportUtils.f(i, e.aa, e.z);
            if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                return true;
            }
            return false;
        };
        a.h = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
        };
        a.r = (b, c, d, e) => {
            if (c < b.m) {
                return b.m;
            }
            else if (c > b.l) {
                return b.l;
            }
            return c;
        };
        return a;
    }
    dz(a, b) {
        return this.ly(a);
    }
    lz(a, b, c, d, e) {
        let f = 0;
        if (b) {
            if (a <= 0) {
                f = (Math.log(this.kd) - this.kj) / (this.ki - this.kj);
            }
            else {
                f = (Math.log(a) - this.kj) / (this.ki - this.kj);
            }
        }
        else {
            f = (a - this.kd) / (this.kc - this.kd);
        }
        if (c) {
            f = 1 - f;
        }
        f = e + (f * (d - e));
        f /= 2;
        return f;
    }
    ly(a) {
        return this.lz(a, this.j3, this.cb, this.ls, this.lr);
    }
    l0(a) {
        let b = a * 2;
        b = (b - this.lr) / (this.ls - this.lr);
        if (this.ca) {
            b = 1 - b;
        }
        if (this.j3) {
            return Math.exp(b * (this.ki - this.kj) + this.kj);
        }
        else {
            return this.kd + b * (this.kc - this.kd);
        }
    }
    d2(a, b) {
        return this.l0(a);
    }
    g0(a, b, c, d) {
        switch (b) {
            case "CrossingValue":
                this.lu = this.lt(this.e5) * Math.PI / 180;
                break;
        }
        super.g0(a, b, c, d);
        switch (b) {
            case NumericRadiusAxis.$$p[1]:
                this.ls = this.l2;
                if (this.ls < 0) {
                    this.ls = 0.1;
                }
                if (this.ls > 1) {
                    this.ls = 1;
                }
                if (this.lr >= this.ls) {
                    this.lr = this.ls - 0.01;
                    if (this.lr < 0) {
                        this.lr = 0;
                        this.ls = 0.01;
                    }
                }
                this.ci = true;
                this.hc(false);
                if (this.lm != null) {
                    this.lm.hb();
                }
                for (let e of fromEnum(this.cw())) {
                    e.k3(false);
                }
                break;
            case NumericRadiusAxis.$$p[0]:
                this.lr = this.l1;
                if (this.lr < 0) {
                    this.lr = 0.1;
                }
                if (this.lr > 1) {
                    this.lr = 1;
                }
                if (this.lr >= this.ls) {
                    this.lr = this.ls - 0.01;
                    if (this.lr < 0) {
                        this.lr = 0;
                        this.ls = 0.01;
                    }
                }
                this.ci = true;
                this.hc(false);
                if (this.lm != null) {
                    this.lm.hb();
                }
                for (let f of fromEnum(this.cw())) {
                    f.d2 = true;
                    f.k3(false);
                }
                if (this.bh != null) {
                    this.bh.jj();
                }
                break;
            case "CrossingAxis":
                let g = typeCast(NumericAngleAxis.$, d);
                let h = typeCast(CategoryAngleAxis.$, d);
                if (g == null && h == null) {
                    this.l7(null);
                }
                if (g != null) {
                    this.l7(g);
                    g.lz(this);
                }
                if (h != null) {
                    this.l7(h);
                    h.l1(this);
                }
                this.ci = true;
                this.hc(false);
                break;
            case "IsInverted":
                if (this.lm != null) {
                    this.lm.ci = true;
                    this.lm.hc(false);
                }
                break;
        }
    }
    l7(a) {
        this.lm = a;
    }
    get lm() {
        if (this.ll != null) {
            return this.ll;
        }
        let a = typeCast(XamDataChart.$, this.bh);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.ll;
    }
    set lm(a) {
        this.ll = a;
    }
    aj() {
        return this.lm;
    }
    jq() {
        return new PolarAxisRenderingParameters();
    }
    jp(a, b, c, d) {
        let e = typeCast(PolarAxisRenderingParameters.$, super.jp(a, b, c, d));
        let f = this.lo.f(b);
        let g = this.lo.g(b);
        let h = 0.5 * this.ls;
        let i = 0.5 * this.lr;
        let j, k;
        if (Rect.l_op_Equality(b, SeriesViewer.o4)) {
            k = this.kc;
            j = this.kd;
        }
        else {
            k = Math.min(g, h);
            j = this.l0(f);
            k = this.l0(k);
            let l = this.l8(a, b, j, k);
            j = l.p2;
            k = l.p3;
        }
        let m = { $type: Point_$type, x: 0.5, y: 0.5 };
        let n = f;
        let o = g;
        let p = Math.min(a.width, a.height) * (this.ls - this.lr) / 2;
        e.center = m;
        let q = Math.max(o, n);
        let r = Math.min(n, o);
        e.maxLength = q;
        e.minLength = r;
        let s = Math.min(j, k);
        let t = Math.max(j, k);
        if (s < this.kd) {
            s = this.kd;
        }
        if (t > this.kc) {
            t = this.kc;
        }
        this.kg = s;
        this.kf = t;
        e.k.add(((() => {
            let $ret = new RangeInfo();
            $ret.d = s;
            $ret.c = t;
            $ret.b = p;
            return $ret;
        })()));
        let u = typeCast(IAngleScaler_$type, this.lm);
        if (u != null) {
            let v;
            let w;
            let x = u.getMinMaxAngle(b, v, w);
            v = x.p1;
            w = x.p2;
            e.minAngle = Math.min(v, w);
            e.maxAngle = Math.max(v, w);
        }
        let y = this.lx();
        if (o >= h) {
            o = y;
        }
        if (n < i) {
            n = i;
        }
        e.minLength = n;
        e.maxLength = o;
        e.effectiveMaximum = y;
        e.f = this.jt;
        let z = typeCast(LinearTickmarkValues.$, e.f);
        if (z != null) {
            z.y = this.l3(m, e.minLength, e.maxLength, b, a);
        }
        return e;
    }
    l8(a, b, c, d) {
        let e = { $type: Point_$type, x: 0.5, y: 0.5 };
        let f = 0;
        if (this.ca) {
            f = this.ly(this.kd);
        }
        else {
            f = this.ly(this.kc);
        }
        let g = 0;
        if (this.e5 != null) {
            g = this.lu;
        }
        let h = e.x + f * Math.cos(g);
        let i = e.y + f * Math.sin(g);
        e.x = ViewportUtils.c(e.x, b, a);
        e.y = ViewportUtils.f(e.y, b, a);
        h = ViewportUtils.c(h, b, a);
        i = ViewportUtils.f(i, b, a);
        if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
            if (this.ca) {
                d = this.kd;
            }
            else {
                d = this.kc;
            }
        }
        if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
            if (this.ca) {
                c = this.kc;
            }
            else {
                c = this.kd;
            }
        }
        return {
            p2: c,
            p3: d
        };
    }
    l3(a, b, c, d, e) {
        let f = ViewportUtils.d(c - b, d, e);
        let g = f / Math.min(e.width, e.height);
        if (g > 0.7) {
            return 10;
        }
        return 5;
    }
    lx() {
        let a = 0;
        if (!this.ca) {
            a = this.ly(this.kc);
        }
        else {
            a = this.ly(this.kd);
        }
        return a;
    }
    lb(a) {
        if (this.lm != null) {
            this.lm.hb();
        }
    }
    hd(a) {
        super.hd(a);
        let b = this.bh != null ? this.bh.os : Rect.empty;
        let c = !b.isEmpty ? this.ja : Rect.empty;
        let d = this.i5();
        let e = this.i4();
        let f = this.jo.c(a, c, b, d, e);
        if (f != null) {
            this.kb = f.f.m;
            this.ke = f.f.l;
        }
    }
    ho(a, b) {
        super.ho(a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cn();
        }
    }
    l6(a, b, c, d, e) {
        let f = typeCast(IPolarRadialRenderingParameters_$type, this.jp(b, c, d, e));
        if (f == null) {
            return;
        }
        this.lo.j(a.d, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
    }
    get_a1() {
        return 3;
    }
    get a1() {
        return this.get_a1();
    }
    i2(a, b, c, d = null, e = null) {
        let f = typeCast(PolarAxisRenderingParameters.$, this.jp(c, b, d, e));
        let g = a;
        let h = new PathGeometry();
        let i = ViewportUtils.d(g, b, c);
        let j = ViewportUtils.g(g, b, c);
        if (i <= 0 || j <= 0) {
            return null;
        }
        let k = ViewportUtils.c(f.center.x, b, c);
        let l = ViewportUtils.f(f.center.y, b, c);
        if (f.maxAngle - f.minAngle < Math.PI && f.maxAngle - f.minAngle > 0) {
            let m = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.minAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.minAngle), b, c) };
            let n = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.maxAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.maxAngle), b, c) };
            let o = new PathFigure();
            o._startPoint = m;
            o._isClosed = false;
            o._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = n;
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            h.c.add(o);
        }
        else {
            let p = new PathFigure();
            p._startPoint = { $type: Point_$type, x: k, y: l - j };
            p._isClosed = true;
            p._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: k, y: l + j };
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            p._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: k, y: l - j };
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            h.c.add(p);
        }
        return h;
    }
}
NumericRadiusAxis.$t = markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
NumericRadiusAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericRadiusAxis, 'g6', ['InnerRadiusExtentScale:l1:l9', [1, 0], 'RadiusExtentScale:l2:ma', [1, 0.75]]);
/**
 * @hidden
 */
export class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    constructor(a) {
        super(a);
        this.ax = null;
        this.ax = a;
    }
    am() {
        super.am();
        this.ax.cu = true;
    }
    ay(a, b) {
        this.ax.cy = -1.7976931348623157E+308;
        this.ax.cv = -1.7976931348623157E+308;
        this.ax.cx = -1.7976931348623157E+308;
        this.ax.cw = -1.7976931348623157E+308;
        for (let c = 0; c < this.a.a4.count; c++) {
            let d = this.a.a4._inner[c];
            let e = this.a.a3._inner[c];
            let f = e.a;
            let g = this.ax.c0(e.c);
            let h = this.m(d);
            let i = this.l(d);
            let j = h + this.p() + this.q();
            let k = i + this.r() + this.o();
            let l = g.x - j / 2;
            let m = g.y - k / 2;
            this.ax.cx = Math.max(h, this.ax.cx);
            this.ax.cw = Math.max(i, this.ax.cw);
            this.ax.cy = Math.max(j, this.ax.cy);
            this.ax.cv = Math.max(k, this.ax.cv);
            let n = new Rect(0, l, m, j, k);
            a.add(n);
            b.add(f);
        }
    }
    o() {
        return 0;
    }
    p() {
        return 0;
    }
    q() {
        return 0;
    }
    r() {
        return 0;
    }
}
AngleAxisLabelPanelView.$t = markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
/**
 * @hidden
 */
export class CategoryAngleAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
CategoryAngleAxisView.$t = markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
/**
 * @hidden
 */
export class NumericAngleAxisView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
NumericAngleAxisView.$t = markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
/**
 * @hidden
 */
export class NumericRadiusAxisView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
NumericRadiusAxisView.$t = markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);
//# sourceMappingURL=AngleAxisLabelPanel_combined.js.map