/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { VerticalAnchoredCategorySeries } from "./VerticalAnchoredCategorySeries";
import { IBarSeries_$type } from "./IBarSeries";
import { DependencyProperty } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { typeCast, fromEnum, runOn, markType, markDep } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { List$1 } from "igniteui-angular-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { BarFramePreparer } from "./BarFramePreparer";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { BarTrendLineManager } from "./BarTrendLineManager";
import { DeviceUtils } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export class BarSeries extends VerticalAnchoredCategorySeries {
    constructor() {
        super();
        this.ab = BarSeries.$;
        this.pz = new BarFramePreparer(1, this, this.sy, this, this, this.sy.cr);
    }
    bp() {
        return new BarSeriesView(this);
    }
    p4() {
        return 1;
    }
    kk(a) {
        super.kk(a);
        this.sy = a;
    }
    get_cu() {
        return true;
    }
    n2(a) {
        if (this.xAxis == null || this.yAxis == null || this.pv.f.count == 0) {
            return Rect.empty;
        }
        let b = this.bs.bv;
        let c = this.bs.bu;
        let d = this.getEffectiveViewport1(this.bs);
        let e = new ScalerParams(0, b, c, this.xAxis.ca, d);
        let f = this.no(a);
        let g = this.gf(a, true);
        let h = this.gd(a, true);
        let i = truncate(Math.floor(g / this.qu(this.bs)));
        let j = truncate(Math.floor(h / this.qu(this.bs)));
        let k = i - this.qv(this.bs);
        let l = j - this.qv(this.bs);
        if (k < 0) {
            k = 0;
        }
        if (k > this.pv.f.count - 1) {
            k = this.pv.f.count - 1;
        }
        if (l < 0) {
            l = 0;
        }
        if (l > this.pv.f.count - 1) {
            l = this.pv.f.count - 1;
        }
        let m = this.pv.f._inner[k];
        let n = this.pv.f._inner[l];
        let o = Math.abs(f.y - m[0]);
        let p = Math.abs(f.y - n[0]);
        let q = this.rv(this.p3);
        let r = this.yAxis.j0(b, c, d);
        if (o < p) {
            let s = m[0] - 0.5 * r;
            let t = m[1];
            let u = q;
            return new Rect(0, Math.min(u, t), s, Math.max(u, t) - Math.min(u, t), r);
        }
        else {
            let v = n[0] - 0.5 * r;
            let w = n[1];
            let x = q;
            return new Rect(0, Math.min(x, w), v, Math.max(x, w) - Math.min(x, w), r);
        }
    }
    dy(a, b) {
        if (this.d1(a, b)) {
            return true;
        }
        if (this.ol(a, b)) {
            return true;
        }
        return false;
    }
    p0(a) {
        let b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.q) {
            if (b.p) {
                return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), b, this, b.cr);
            }
            else {
                return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), this.b6.b8.o, this, b.cr);
            }
        }
        else {
            return this.pz;
        }
    }
    ac() {
        super.ac();
    }
    preferredCategoryMode(a) {
        return 2;
    }
    jl(a, b) {
        super.jl(a, b);
        let c = typeCast(BarSeriesView.$, b);
        if (a && c != null && c.db != null) {
            c.db.count = 0;
        }
    }
    qx() {
        let a = 0;
        for (let b of fromEnum(this.b6.series)) {
            if (b == this) {
                return a;
            }
            let c = typeCast(IBarSeries_$type, b);
            if (c != null && c.yAxis == this.yAxis && c.getPreferredCategoryMode() == 2) {
                a++;
            }
        }
        return -1;
    }
    rv(a) {
        let b = 0;
        let c = a.bv;
        let d = a.bu;
        let e = this.getEffectiveViewport1(a);
        if (!c.isEmpty && !d.isEmpty && this.xAxis != null) {
            let f = new ScalerParams(0, c, d, this.xAxis.ca, e);
            b = this.xAxis.dz(this.xAxis.kn, f);
        }
        return b;
    }
    ao(a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.yAxis) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.xAxis) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    }
    dq(a) {
        let b = this.bs.bv;
        b = b.copy();
        let c = this.bs.bu;
        let d = new Rect(0, 0, 0, 1, 1);
        let e = !b.isEmpty && !c.isEmpty && this.cd != null ? this.cd.indexOf(a) : -1;
        let f = this.n0(this.bs);
        let g = new ScalerParams(0, d, d, this.xAxis.ca, f);
        let h = new ScalerParams(0, d, d, this.yAxis.ca, f);
        let i = this.yAxis != null ? this.yAxis.dz(e, h) : NaN;
        let j = this.yAxis != null ? this.pz.r(this.yAxis, d, d, f) : 0;
        i += j;
        let k = this.xAxis != null && this.valueColumn != null && e < this.valueColumn.count ? this.xAxis.dz(this.valueColumn.item(e), g) : NaN;
        if (!isNaN_(k)) {
            if (k < b.left + 0.1 * b.width) {
                k = k + 0.4 * b.width;
                b.x = k - 0.5 * b.width;
            }
            if (k > b.right - 0.1 * b.width) {
                k = k - 0.4 * b.width;
                b.x = k - 0.5 * b.width;
            }
        }
        if (!isNaN_(i)) {
            if (i < b.top + 0.1 * b.height) {
                i = i + 0.4 * b.height;
                b.y = i - 0.5 * b.height;
            }
            if (i > b.bottom - 0.1 * b.height) {
                i = i - 0.4 * b.height;
                b.y = i - 0.5 * b.height;
            }
        }
        if (this.b1 != null) {
            this.b1.ap(this.b6, b, true);
        }
        return e >= 0;
    }
    e9() {
        return this.yAxis.j0(this.bs.bv, this.bs.bu, this.getEffectiveViewport1(this.bs));
    }
    rc(a, b) {
        super.rc(a, b);
        let c = a.f;
        if (!b.o()) {
            return;
        }
        let d = b.bv;
        let e = b.bu;
        let f = this.getEffectiveViewport1(b);
        let g = new ScalerParams(0, d, e, this.xAxis.ca, f);
        let h = this.yAxis;
        let i = new ScalerParams(0, d, e, this.yAxis.ca, f);
        let j = this.xAxis;
        let k = j.dz(j.kn, g);
        let l = this.yAxis.j0(d, e, f);
        let m = typeCast(BarSeriesView.$, b);
        if (isNaN_(l) || isInfinity(l) || isNaN_(k)) {
            m.db.count = 0;
            return;
        }
        this.p2.a0(this, this.qm(), runOn(this, this.po), this.qu(b), this.qv(b));
        this.p2.r = this.sz;
        this.p2.s = this.s0;
        this.p2.k = this.sz;
        this.p2.l = this.s0;
        let n = false;
        let o = this.p2.b;
        if (o != null) {
            n = true;
        }
        let p = this.xAxis.cf;
        let q = this.valueColumn.count;
        for (let r = 0; r < c.count; ++r) {
            let s = c._inner[r][0] - 0.5 * l;
            let t = c._inner[r][1];
            let u = k;
            u = Math.max(u, -100);
            t = Math.min(t, e.right + 100);
            let v = m.db.item(r);
            v.height = l;
            v.width = Math.abs(t - u);
            if (n) {
                this.q8(c, r, q, h, i, b.q);
            }
            this.p2.ad(v, false, false, false, false);
            v.am = this.p2.k;
            v.an = this.p2.l;
            m.dg(v, Math.min(t, u), s);
        }
        m.db.count = c.count;
        b.cy(a);
    }
    jo(a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.rm.cr.g(this.fq);
                break;
        }
        if (this.rm.c3) {
            this.rm.c2.g$e(a, b, c, d);
        }
        switch (a) {
            case 4:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.k3(true);
                }
                break;
            case 1:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.k3(true);
                }
                break;
            case 0:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.k3(true);
                }
                break;
            case 2:
                if (this.r2 != null && this.rm.cr.d > 0) {
                    this.k3(true);
                }
                break;
            case 3:
                if (d == this.r2) {
                    if (this.xAxis != null && !this.xAxis.cn()) {
                        this.k3(true);
                    }
                }
                break;
        }
    }
    kp(a, b, c, d) {
        super.kp(a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.rm.cr.g(this.fq);
                if (this.xAxis != null && this.xAxis.cn()) {
                    this.k3(false);
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if (this.rm.c3) {
                    this.rm.c2 = CategoryTrendLineManagerFactory.a(this.rm.c2, this.yAxis, this.ls, this, this.cg);
                }
                this.rm.cr.g(this.fq);
                this.k3(false);
                break;
            case "FastItemsSource":
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.rm.cr.g(this.fq);
                    this.k3(false);
                }
                break;
            case "ValueColumn":
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.rm.cr.g(this.fq);
                    this.k3(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    this.jp(this.xAxis);
                    this.jp(this.yAxis);
                }
                if (c == null && d != null) {
                    this.ku(this.xAxis);
                    this.ku(this.yAxis);
                }
                this.rm.cr.g(this.fq);
                this.k3(false);
                break;
        }
    }
    getPreferredCategoryMode() {
        return this.preferredCategoryMode(this.yAxis);
    }
    get useHighMarkerFidelity() {
        return this.qp;
    }
}
BarSeries.$t = markType(BarSeries, 'BarSeries', VerticalAnchoredCategorySeries.$, [IBarSeries_$type]);
BarSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BarSeries, 'raisePropertyChanged', ['RadiusX:sz:s3', [1, 0], 'RadiusY:s0:s4', [1, 0]]);
/**
 * @hidden
 */
export class BarBucketCalculator extends CategoryBucketCalculator {
    constructor(a) {
        super(a);
        this.i = null;
        this.h = null;
        this.j = 0;
        this.i = a;
    }
    g(a) {
        let b = this.c.bv;
        let c = this.c.bu;
        let d = this.c.ct.cd;
        if (b.isEmpty || c.isEmpty || this.i.da.yAxis == null || d == null || d.count == 0) {
            this.d = 0;
            return;
        }
        let e = typeCast(BarSeries.$, this.c.ct);
        let f = e.ny(this.c);
        let g = e.getEffectiveViewport1(this.c);
        let h = new ScalerParams(0, b, c, e.yAxis.ca, g);
        let i = Math.floor(e.yAxis.d3(f.top, h, 0));
        let j = Math.ceil(e.yAxis.d3(f.bottom, h, 0));
        if (!e.yAxis.ca) {
            j = Math.ceil(e.yAxis.d3(f.top, h, 0));
            i = Math.floor(e.yAxis.d3(f.bottom, h, 0));
        }
        let k = Math.floor((j - i + 1) * a / f.height);
        this.d = truncate(Math.max(1, k));
        this.e = truncate(Math.max(0, Math.floor(i / this.d) - 1));
        this.f = truncate(Math.ceil(j / this.d));
    }
    getBucketWithoutUnknowns(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = 1.7976931348623157E+308;
        let h = -1.7976931348623157E+308;
        let i = true;
        for (let j = d; j <= e; ++j) {
            let k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            Math.max(h, k);
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    getBucket(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = NaN;
        let h = NaN;
        for (let i = d; i <= e; ++i) {
            let j = b[i];
            if (!isNaN_(g)) {
                if (!isNaN_(j)) {
                    g = Math.min(g, j);
                    h = Math.max(h, j);
                }
            }
            else {
                g = j;
                h = j;
            }
        }
        if (!isNaN_(g)) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    cacheValues() {
        this.j = this.i.da.valueColumn.count;
        this.h = this.i.da.valueColumn.asArray();
    }
    unCacheValues() {
        this.h = null;
    }
}
BarBucketCalculator.$t = markType(BarBucketCalculator, 'BarBucketCalculator', CategoryBucketCalculator.$);
/**
 * @hidden
 */
export class BarSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.da = null;
        this.db = null;
        this.dc = null;
        this.dh = new Rectangle();
        this.da = a;
        this.db = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.di);
            $ret.activate = runOn(this, this.dd);
            $ret.disactivate = runOn(this, this.df);
            $ret.destroy = runOn(this, this.de);
            return $ret;
        })());
        this.c2 = new BarTrendLineManager();
    }
    as() {
        super.as();
        this.dc = new List$1(Rectangle.$, 0);
        if (!this.q) {
            this.e.fq = 4;
            this.e.bx = 1;
            this.e.fv = DeviceUtils.g(1);
        }
    }
    di() {
        let a = new Rectangle();
        this.dc.add(a);
        a._visibility = 1;
        return a;
    }
    dd(a) {
        a._visibility = 0;
    }
    df(a) {
        a._visibility = 1;
    }
    de(a) {
        this.dc.remove(a);
    }
    dg(a, b, c) {
        if (!this.isDirty) {
            this.aq();
        }
        a.o = c;
        a.n = b;
    }
    cs() {
        return new BarBucketCalculator(this);
    }
    bf(a, b) {
        super.bf(a, b);
        let c = a;
        let d = this.bp(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.eu;
    }
    ac(a) {
        return this.dc._inner[a];
    }
    ab(a) {
        let b = this.dc._inner[a];
        this.dh.n = b.n;
        this.dh.o = b.o;
        this.dh.width = b.width;
        this.dh.height = b.height;
        let c = this.bp(a);
        this.dh._fill = c;
        this.dh._stroke = c;
        this.dh.ac = this.e.eu + 3;
        return this.dh;
    }
    a6(a, b) {
        super.a6(a, b);
        if (a.d) {
            for (let c = 0; c < this.dc.count; c++) {
                let d = this.aa(c, b);
                this.bd(d, c, b);
                a.v(d);
            }
        }
    }
    al(a) {
        super.al(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.db.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.o > f.o) {
                return -1;
            }
            else if (e.o < f.o) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            this.e.a5.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
        }
        b++;
    }
    af() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.ni = a;
        this.e.fs = 5;
        this.e.ft = 5;
        this.e.fu = -5;
    }
}
BarSeriesView.$t = markType(BarSeriesView, 'BarSeriesView', AnchoredCategorySeriesView.$);
//# sourceMappingURL=BarSeries_combined.js.map