/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ChaikinVolatilityIndicatorStrategy } from "./ChaikinVolatilityIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class ChaikinVolatilityIndicator extends StrategyBasedIndicator {
    get_sk() {
        return new ChaikinVolatilityIndicatorStrategy();
    }
    get sk() {
        return this.get_sk();
    }
    get_sx() {
        return ChaikinVolatilityIndicator.$;
    }
    get sx() {
        return this.get_sx();
    }
    get s5() {
        return typeGetValue(this.c(ChaikinVolatilityIndicator.s6));
    }
    set s5(a) {
        this.h(ChaikinVolatilityIndicator.s6, a);
    }
    sq() {
        return this.s5;
    }
    sz(a) {
        this.s5 = a;
    }
}
ChaikinVolatilityIndicator.$t = markType(ChaikinVolatilityIndicator, 'ChaikinVolatilityIndicator', StrategyBasedIndicator.$);
ChaikinVolatilityIndicator.s6 = StrategyBasedIndicator.s2(10, ChaikinVolatilityIndicator.$);
//# sourceMappingURL=ChaikinVolatilityIndicator.js.map