/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { PercentagePriceOscillatorIndicatorStrategy } from "./PercentagePriceOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class PercentagePriceOscillatorIndicator extends StrategyBasedIndicator {
    get_sk() {
        return new PercentagePriceOscillatorIndicatorStrategy();
    }
    get sk() {
        return this.get_sk();
    }
    get_sx() {
        return PercentagePriceOscillatorIndicator.$;
    }
    get sx() {
        return this.get_sx();
    }
    get shortPeriod() {
        return typeGetValue(this.c(PercentagePriceOscillatorIndicator.s6));
    }
    set shortPeriod(a) {
        this.h(PercentagePriceOscillatorIndicator.s6, a);
    }
    ss() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(PercentagePriceOscillatorIndicator.s5));
    }
    set longPeriod(a) {
        this.h(PercentagePriceOscillatorIndicator.s5, a);
    }
    sp() {
        return this.longPeriod;
    }
}
PercentagePriceOscillatorIndicator.$t = markType(PercentagePriceOscillatorIndicator, 'PercentagePriceOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
PercentagePriceOscillatorIndicator.s6 = StrategyBasedIndicator.s4(10, PercentagePriceOscillatorIndicator.$);
PercentagePriceOscillatorIndicator.s5 = StrategyBasedIndicator.s0(30, PercentagePriceOscillatorIndicator.$);
//# sourceMappingURL=PercentagePriceOscillatorIndicator.js.map