/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { typeCast, runOn, markType } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { ISortingAxis_$type } from "./ISortingAxis";
/**
 * @hidden
 */
export class SplineSeries extends SplineSeriesBase {
    constructor() {
        super();
        this.tg = null;
        this.tg = new CategoryLineRasterizer();
        this.ab = SplineSeries.$;
    }
    bp() {
        return new SplineSeriesView(this);
    }
    kk(a) {
        super.kk(a);
        this.th = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    jl(a, b) {
        super.jl(a, b);
        let c = b;
        c.dc();
    }
    rc(a, b) {
        super.rc(a, b);
        let c = b;
        let d = c.cr.d;
        let e = typeCast(SplineSeriesView.$, b);
        let f = a.f;
        let g = this.getEffectiveViewport1(b);
        this.p2.a0(this, this.qm(), runOn(this, this.po), this.qu(b), this.qv(b));
        let h = false;
        let i = this.p2.b;
        if (i != null) {
            h = true;
        }
        if (h) {
            let j = new ScalerParams(0, b.bv, b.bu, this.sn.ca, g);
            this.q8(f, -1, this.valueColumn.count, this.sn, j, b.q);
        }
        let k = e.di;
        let l = e.dj;
        let m = e.dh;
        this.p2.ad(k, true, false, true, false);
        this.p2.ad(l, true, false, true, false);
        this.p2.ad(m, false, true, false, false);
        m._opacity = 0.75 * this.p2.j;
        if (b.cv(a)) {
            e.dd(f.count, f, true, 1, this.rk(f, f.count - 1, b.bu, b.bv), d, this.fq);
            b.cy(a);
        }
    }
    get useHighMarkerFidelity() {
        return this.qp;
    }
}
SplineSeries.$t = markType(SplineSeries, 'SplineSeries', SplineSeriesBase.$);
/**
 * @hidden
 */
export class SplineSeriesView extends SplineSeriesBaseView {
    constructor(a) {
        super(a);
        this.db = null;
        this.dl = new Path();
        this.dk = new Path();
        this.dm = new Path();
        this.dg = new Path();
        this.df = new Path();
        this.de = new Path();
        this.db = a;
    }
    get di() {
        return this.dl;
    }
    get dj() {
        return this.dm;
    }
    get dh() {
        return this.dk;
    }
    dc() {
        this.dk.ak = null;
        this.dl.ak = null;
        this.dm.ak = null;
        this.aq();
    }
    dd(a, b, c, d, e, f, g) {
        this.db.tg.a = typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
        this.db.tg.m(this.dl, this.dk, this.dm, a, b, c, d, e, f, g);
        this.aq();
    }
    bc() {
        super.bc();
        this.df.ak = this.dl.ak;
        this.dg.ak = this.dm.ak;
        this.de.ak = this.dk.ak;
        let a = this.bo();
        this.df._stroke = a;
        this.df.ac = this.e.eu + 3;
        this.dg._stroke = a;
        this.dg.ac = this.e.eu + 3;
        this.de._fill = a;
        this.de._opacity = 1;
    }
    a6(a, b) {
        super.a6(a, b);
        if (a.d) {
            if (b) {
                a.s(this.de);
                a.s(this.df);
                a.s(this.dg);
            }
            else {
                a.s(this.dk);
                a.s(this.dl);
                a.s(this.dm);
            }
        }
    }
    al(a) {
        super.al(a);
        this.e.a5.exportPathData(a, this.dl, "lowerShape", ["Lower", "Main"]);
        this.e.a5.exportPathData(a, this.dm, "upperShape", ["Upper"]);
        this.e.a5.exportPathData(a, this.dk, "translucentShape", ["Translucent"]);
    }
}
SplineSeriesView.$t = markType(SplineSeriesView, 'SplineSeriesView', SplineSeriesBaseView.$);
//# sourceMappingURL=SplineSeries_combined.js.map