/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StackedColumnSeries } from "./StackedColumnSeries";
import { IStacked100Series_$type } from "./IStacked100Series";
import { markType } from "igniteui-angular-core";
import { Stacked100DataPreparer } from "./Stacked100DataPreparer";
import { StackedColumnSeriesView } from "./StackedColumnSeriesView";
import { Stacked100ColumnBucketCalculator } from "./Stacked100ColumnBucketCalculator";
import { DeviceUtils } from "igniteui-angular-core";
/**
 * @hidden
 */
export class Stacked100ColumnSeries extends StackedColumnSeries {
    constructor() {
        super();
        this.ab = Stacked100ColumnSeries.$;
    }
    get_ru() {
        return true;
    }
    ac() {
        super.ac();
        this.k3(false);
    }
    bp() {
        return new Stacked100ColumnSeriesView(this);
    }
    kk(a) {
        super.kk(a);
        this.sy = a;
    }
    rm() {
        return this.sy;
    }
    sa() {
        super.sa();
        Stacked100DataPreparer.a(this);
    }
    get useHighMarkerFidelity() {
        return this.qp;
    }
}
Stacked100ColumnSeries.$t = markType(Stacked100ColumnSeries, 'Stacked100ColumnSeries', StackedColumnSeries.$, [IStacked100Series_$type]);
/**
 * @hidden
 */
export class Stacked100ColumnSeriesView extends StackedColumnSeriesView {
    constructor(a) {
        super(a);
        this.c5 = null;
        this.c5 = a;
    }
    cs() {
        return new Stacked100ColumnBucketCalculator(this);
    }
    as() {
        super.as();
        if (!this.q) {
            this.e.fv = DeviceUtils.g(1);
        }
    }
}
Stacked100ColumnSeriesView.$t = markType(Stacked100ColumnSeriesView, 'Stacked100ColumnSeriesView', StackedColumnSeriesView.$);
//# sourceMappingURL=Stacked100ColumnSeries_combined.js.map