/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryTooltipLayerPosition_$type } from "./CategoryTooltipLayerPosition";
import { CategoryToolTipLayerFrame } from "./CategoryToolTipLayerFrame";
import { Base, enumGetBox, typeCast, fromEnum, Point_$type, markType, markDep, String_$type } from "igniteui-angular-core";
import { Series } from "./Series";
import { CategoryTooltipSeriesInfo } from "./CategoryTooltipSeriesInfo";
import { XamDataChart } from "./XamDataChart";
import { List$1 } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { PointerTooltip } from "./PointerTooltip";
/**
 * @hidden
 */
var CategoryToolTipLayer = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryToolTipLayer, _super);
    function CategoryToolTipLayer() {
        var _this = _super.call(this) || this;
        var a = new CategoryToolTipLayerFrame();
        var b = new CategoryToolTipLayerFrame();
        var c = new CategoryToolTipLayerFrame();
        _this.ob = a;
        _this.oa = b;
        _this.oc = c;
        _this.ab = CategoryToolTipLayer.$;
        return _this;
    }
    CategoryToolTipLayer.prototype.bp = function () {
        return new CategoryToolTipLayerView(this);
    };
    CategoryToolTipLayer.prototype.kk = function (a) {
        _super.prototype.kk.call(this, a);
        this.pf = a;
    };
    CategoryToolTipLayer.prototype.get_c2 = function () {
        return true;
    };
    CategoryToolTipLayer.prototype.kp = function (a, b, c, d) {
        _super.prototype.kp.call(this, a, b, c, d);
        switch (b) {
            case CategoryToolTipLayer.$$p[0]:
                this.k3(true);
                break;
            case CategoryToolTipLayer.$$p[2]:
                this.k3(true);
                break;
            case CategoryToolTipLayer.$$p[1]:
                this.k3(true);
                break;
            case "SeriesViewer":
                this.pf.cf();
                break;
        }
    };
    CategoryToolTipLayer.prototype.ot = function (a, b) {
        if (this.pd == a) {
            if (!this.ar.c) {
                this.k3(b);
            }
        }
    };
    CategoryToolTipLayer.prototype.ou = function (a, b) {
        if (!this.ar.c) {
            this.k3(b);
        }
    };
    CategoryToolTipLayer.prototype.ow = function (a, b) {
        var e_1, _a, e_2, _b;
        _super.prototype.ow.call(this, a, b);
        var c = a;
        var d = this.ph;
        c.l = NaN;
        c.k = NaN;
        c.g = NaN;
        c.h = NaN;
        c.k = NaN;
        c.l = NaN;
        if (isNaN_(this.pa.x) && isNaN_(this.pa.y)) {
            this.pf.cd(this.pf.ca());
            return;
        }
        if (this.pd != null) {
            var e = this.pd;
            if (e == null || !e.b4 || e.b2) {
                return;
            }
            if (!e.cg()) {
                return;
            }
            var f = e;
            var g = this.pg(f.cz, d);
            this.pm(g, c, d);
        }
        else {
            if (typeCast(XamDataChart.$, this.b6) !== null) {
                var h = this.b6;
                var i = true;
                var j = false;
                var k = new List$1(Series.$, 0);
                try {
                    for (var _c = tslib_1.__values(fromEnum(h.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var l = _d.value;
                        if (l.b4 && !l.b2) {
                            if (!l.cg()) {
                                continue;
                            }
                            if (i) {
                                i = false;
                                j = l.ch;
                            }
                            else {
                                if (l.ch != j) {
                                    continue;
                                }
                            }
                            try {
                                for (var _e = (e_2 = void 0, tslib_1.__values(fromEnum(l.cz))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                    var m = _f.value;
                                    k.add(m);
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                var n = this.pg(k, d);
                this.pm(n, c, d);
            }
        }
    };
    CategoryToolTipLayer.prototype.pg = function (a, b) {
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        var e = new List$1(DataContext.$, 0);
        var f = new List$1(Base.$, 0);
        var g = false;
        var h = true;
        for (var i = 0; i < a.count; i++) {
            var j = a.item(i);
            if (!j.c6 && !j.cz) {
                continue;
            }
            if (j.isStacked) {
                continue;
            }
            var k = j;
            if (!k.categoryAxis.cg()) {
                continue;
            }
            if (h) {
                g = j.isVertical;
            }
            else {
                if (g != j.isVertical) {
                    continue;
                }
            }
            var l = this.op(j);
            if (!l.c) {
                continue;
            }
            var m = j.nt(l.d, b, false);
            if (g) {
                if (!isNaN_(m.y)) {
                    c = Math.min(c, m.y);
                    d = Math.max(d, m.y);
                }
            }
            else {
                if (!isNaN_(m.x)) {
                    c = Math.min(c, m.x);
                    d = Math.max(d, m.x);
                }
            }
            var n = this.pi(j);
            if (n == null) {
                continue;
            }
            var o = null;
            var p = j.gq(this.pa);
            if (j.c3 && p != null) {
                o = j.at(p);
            }
            else {
                o = new DataContext();
                o.item = p;
                o.series = j;
            }
            e.add(o);
            f.add1(n);
        }
        var q = 0;
        var r = 0;
        if (g) {
            r = (c + d) / 2;
            q = this.n6.right;
            if (this.pe == 2 || this.pe == 1) {
                q = this.n6.left;
            }
            if (r < 0 || r > this.n6.bottom) {
                r = NaN;
            }
        }
        else {
            q = (c + d) / 2;
            r = this.n6.top;
            if (this.pe == 2 || this.pe == 1) {
                r = this.n6.bottom;
            }
            if (q < 0 || q > this.n6.right) {
                q = NaN;
            }
        }
        var s = new CategoryTooltipSeriesInfo();
        s.c = { $type: Point_$type, x: q, y: r };
        s.a = e;
        s.b = f;
        return s;
    };
    CategoryToolTipLayer.prototype.j1 = function () {
        this.pa = { $type: Point_$type, x: NaN, y: NaN };
        this.bs.ap();
    };
    CategoryToolTipLayer.prototype.pm = function (a, b, c) {
        var d = a.c;
        var e = a.a;
        var f = a.b;
        d = this.pf.cg(d);
        var g = 0;
        var h = this.bs.bu;
        var i = this.pf.ca();
        this.pf.cc();
        var j = false;
        if (e.count == 0) {
            this.bs.ap();
            return;
        }
        var k = false;
        for (var l = 0; l < e.count; l++) {
            var m = e._inner[l].series;
            j = m.isVertical;
            var n = e._inner[l];
            var o = f._inner[l];
            if (this.pf.b7(m, o, n)) {
                k = true;
            }
            g++;
        }
        if (!k) {
            this.pf.cd(i);
            return;
        }
        var p = this.pf.ch(i);
        var q = 0;
        var r = 0;
        var s = 0;
        var t = 0;
        var u = false;
        var v = false;
        var w = this.pe;
        if (w == 2 || w == 3) {
            v = true;
        }
        if (w == 2 || w == 1) {
            u = true;
        }
        var x = this.pf.ci();
        if (j) {
            if (!u && !v && d.x + (p.width + DeviceUtils.g(10)) > x.width) {
                v = true;
            }
            if (u && !v && d.x - (p.width + DeviceUtils.g(10)) < 0) {
                v = true;
            }
        }
        else {
            if (!u && !v && d.y - (p.height + 10) < 0) {
                v = true;
            }
            if (u && !v && d.y + (p.height + 10) > x.height) {
                v = true;
            }
        }
        var y = DeviceUtils.g(10);
        var z = DeviceUtils.g(5);
        if (!u) {
            if (!j) {
                z = p.height + y;
            }
            if (v) {
                if (j) {
                    z = z + p.width + y;
                }
                else {
                    z = 0;
                }
            }
        }
        else {
            if (j) {
                z = p.width + y;
                if (v) {
                    z = 0;
                }
            }
            else {
                z = DeviceUtils.g(5);
                if (v) {
                    z = z + p.height + y;
                }
            }
        }
        if (j) {
            r = 0 - (y + DeviceUtils.g(5));
            if (u) {
                r = (r * -1) + p.width;
            }
            q = p.height / 2;
            t = d.y - p.height / 2;
            s = d.x - z;
        }
        else {
            q = p.height + DeviceUtils.g(10) + DeviceUtils.g(5);
            if (u) {
                q = 0 - (y + DeviceUtils.g(5));
            }
            r = p.width / 2;
            s = d.x - p.width / 2;
            t = d.y - z;
        }
        if (j) {
            if (t < 0) {
                q -= 0 - t;
                t = 0;
            }
            if (t + p.height > x.height) {
                q += (t + p.height) - x.height;
                t = x.height - p.height;
            }
        }
        else {
            if (s < 0) {
                r -= 0 - s;
                s = 0;
            }
            if (s + p.width > x.width) {
                r += (s + p.width) - x.width;
                s = x.width - p.width;
            }
        }
        b.k = s;
        b.l = t;
        b.g = r;
        b.h = q;
        b.j = p.width;
        b.i = p.height;
    };
    CategoryToolTipLayer.prototype.pi = function (a) {
        return a.toolTip;
    };
    CategoryToolTipLayer.prototype.oz = function (a, b) {
        _super.prototype.oz.call(this, a, b);
        var c = a;
        var d = b.bu.left;
        var e = b.bu.right;
        var f = b.bu.top;
        var g = b.bu.bottom;
        var h = this.pf.ca();
        if (isNaN_(c.k) || isNaN_(c.l) || isNaN_(c.g) || isNaN_(c.h)) {
            this.pf.cd(h);
            return;
        }
        var i = c.k;
        var j = c.l;
        var k = c.g;
        var l = c.h;
        this.pf.ce(h, i, j, k, l);
    };
    CategoryToolTipLayer.prototype.dp = function () {
        return true;
    };
    CategoryToolTipLayer.$t = markType(CategoryToolTipLayer, 'CategoryToolTipLayer', AnnotationLayer.$);
    CategoryToolTipLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryToolTipLayer, 'raisePropertyChanged', ['TargetAxis:pd:pn', [Axis.$, null], 'ToolTipPosition:pe:po', [CategoryTooltipLayerPosition_$type, enumGetBox(CategoryTooltipLayerPosition_$type, 0)], 'UseInterpolation:ph:pp', [0, false]]);
    return CategoryToolTipLayer;
}(AnnotationLayer));
export { CategoryToolTipLayer };
/**
 * @hidden
 */
var CategoryToolTipLayerView = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryToolTipLayerView, _super);
    function CategoryToolTipLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b4 = null;
        _this.b5 = null;
        _this._tooltips = null;
        _this.b8 = null;
        _this.b6 = false;
        _this._htmlTest = null;
        _this.b4 = a;
        _this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
        return _this;
    }
    CategoryToolTipLayerView.prototype.ca = function () {
        if (this.b5 == null) {
            this.b5 = new PointerTooltip();
            this.b5.bs(this.e.f5);
            this.b5.ao = this.e.b6.b8.k;
            this._tooltips = this.e.f5.createElement("div");
            this.b8 = this.e.f5.createElement("div");
            this.b5._visibility = 0;
        }
        return this.b5;
    };
    CategoryToolTipLayerView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (this.b5 != null) {
            this.b5._visibility = 1;
        }
    };
    CategoryToolTipLayerView.prototype.aj = function () {
        _super.prototype.aj.call(this);
        if (this.b5 != null) {
            this.b5.bo();
            this.b5 = null;
        }
    };
    Object.defineProperty(CategoryToolTipLayerView.prototype, "htmlTest", {
        get: function () {
            return this._htmlTest;
        },
        set: function (a) {
            this._htmlTest = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryToolTipLayerView.prototype.b7 = function (a, b, c) {
        if (a.g0 == "default") {
            a.g0 = a.bs.getDefaultTooltipTemplate();
        }
        var template_ = a.g0;
        var context_ = c;
        if (a.toolTip == null) {
            return false;
        }
        var tooltip_ = a.toolTip;
        if ((tooltip_.updateToolTip)) {
            tooltip_._inPointer = true;
            tooltip_.updateToolTip(context_, true);
            tooltip_.setStyleProperty('position', 'relative');
            tooltip_.setStyleProperty('left', '');
            tooltip_.setStyleProperty('top', '');
            tooltip_.remove();
        }
        this._tooltips.append(a.toolTip);
        return true;
    };
    CategoryToolTipLayerView.prototype.ch = function (a) {
        var b = a;
        b.content = this._tooltips;
        var c = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        b.ct = 1;
        var d = b.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        b.ct = 0;
        return d;
    };
    CategoryToolTipLayerView.prototype.cg = function (a) {
        var b = 0;
        var c = 0;
        if (this.e.b6 != null) {
            var d = this.e.b6.ol();
            b += d.x;
            c += d.y;
        }
        return { $type: Point_$type, x: b + a.x, y: c + a.y };
    };
    CategoryToolTipLayerView.prototype.ce = function (a, b, c, d, e) {
        var f = a;
        var g = f.content;
        f.cn = { $type: Point_$type, x: d, y: e };
        f._visibility = 0;
        f.n = b;
        f.o = c;
    };
    CategoryToolTipLayerView.prototype.ci = function () {
        var a = (window.innerWidth);
        var b = (window.innerHeight);
        return new Size(1, a, b);
    };
    CategoryToolTipLayerView.prototype.cd = function (a) {
        this._tooltips.removeChildren();
        this.b8.removeChildren();
        this.b5._visibility = 1;
    };
    CategoryToolTipLayerView.prototype.cc = function () {
        if (this._tooltips != null) {
            this._tooltips.removeChildren();
        }
    };
    CategoryToolTipLayerView.prototype.cf = function () {
    };
    CategoryToolTipLayerView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (b) {
            return;
        }
        var c = null;
        if (this.e.b6 != null) {
            c = this.e.b6.b8.j.i();
        }
        var d = 0;
        var e = 0;
        var f = this.e.b6;
        if (f != null) {
            var g = f.b8.j.b7();
            d += g.x;
            e += g.y;
        }
        if (this.b5 != null) {
            this.b5.ap = c;
            this.b5.bu(this.b5.n, this.b5.o);
        }
    };
    CategoryToolTipLayerView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        var b = this.b5;
        var c = 0;
        var d = 0;
        if (this.e.b6 != null) {
            var e = this.e.b6.ol();
            c += e.x;
            d += e.y;
        }
        var f = b.a3();
        var g = b.n - c;
        var h = b.o - d;
        var i = new List$1(String_$type, 0);
        var j = this._tooltips.getChildCount();
        for (var k = 0; k < j; k++) {
            var indexliteral_ = k.toString();
            var l = this._tooltips.getChildAt(k).getText();
            var m = l.toString();
            i.add(m);
        }
        this.e.a5.addPointerTooltipData(a, f, g, h, i);
    };
    CategoryToolTipLayerView.$t = markType(CategoryToolTipLayerView, 'CategoryToolTipLayerView', AnnotationLayerView.$);
    return CategoryToolTipLayerView;
}(AnnotationLayerView));
export { CategoryToolTipLayerView };
//# sourceMappingURL=CategoryToolTipLayer_combined.js.map