/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Brush } from "igniteui-angular-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType_$type } from "igniteui-angular-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core";
import { SubCollectionsRule } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-angular-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-angular-core";
import { timeSpanFromDays } from "igniteui-angular-core";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-angular-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.r1 = null;
        _this.uj = null;
        _this.uh = null;
        _this.ue = null;
        _this.ug = null;
        _this.ui = null;
        _this.uf = null;
        _this.q7 = null;
        _this.u1 = null;
        _this.u2 = null;
        _this.uy = null;
        _this.u3 = null;
        _this.u4 = null;
        _this.uz = null;
        _this.u0 = null;
        _this.sp = null;
        _this.tu = 40;
        _this.rv = null;
        _this.rt = null;
        _this.rx = null;
        _this.r2 = null;
        _this.vc = null;
        _this.sl = null;
        _this.s9 = false;
        _this.s8 = false;
        _this.te = false;
        _this.sv = false;
        _this.up = 10;
        _this.tw = NaN;
        _this.ty = NaN;
        _this.tx = NaN;
        _this.tz = 0;
        _this.rd = 0;
        _this.rg = 0;
        _this.ri = 0;
        _this.ss = true;
        _this.q9 = 0;
        _this.st = false;
        _this.rn = null;
        _this.rp = null;
        _this.tg = null;
        _this.su = true;
        _this.sm = null;
        _this.rk = 1;
        _this.qb = null;
        _this.qc = null;
        _this.qd = null;
        _this.qe = null;
        _this.qg = null;
        _this.qf = null;
        _this.qa = null;
        _this.p9 = null;
        _this.tv = 1;
        _this.tt = 1;
        _this.ts = 1;
        _this.rz = null;
        _this.ul = -2147483648;
        _this.tr = 2;
        _this.uo = 3;
        _this.um = 10;
        _this.uk = 30;
        _this.un = 9;
        _this.q4 = null;
        _this.q5 = null;
        _this.q0 = null;
        _this.applyCustomIndicators = null;
        _this.yx = null;
        _this.t0 = 1;
        _this.sr = false;
        _this.rr = null;
        _this.to = dateMinValue();
        _this.tn = dateMaxValue();
        _this.tl = null;
        _this.hf();
        _this.tl = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.ym(); });
        }
        _this.x7();
        return _this;
    }
    FinancialChart.prototype.ig = function (a, b, c) {
        _super.prototype.ig.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.q8 = new FinancialChartToolbar(this, this.u9);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.xv));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.xy));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.xz));
                    d.l(null);
                }
                if (this.q8 != null) {
                    this.q8.ac = this.rf;
                    this.q8.ai = this.a9;
                    this.q8.y = this.ra;
                    this.q8.al = this.s6;
                    if (this.ug != null) {
                        this.q8.l(this.ug);
                    }
                    var e = this.q8;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.xv));
                    ;
                    var f = this.q8;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.xy));
                    var g = this.q8;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.xz));
                }
                break;
            case "ChartType":
                if (this.q8 != null) {
                    this.q8.y = this.ra;
                }
                break;
            case "VolumeType":
                if (this.q8 != null) {
                    this.q8.ac = this.rf;
                }
                break;
            case "TrendLineType":
                if (this.q8 != null) {
                    this.q8.ai = this.a9;
                }
                break;
            case "IsToolbarVisible":
                if (this.q8 == null) {
                    break;
                }
                this.q8.al = this.s6;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.xz = function (a, b) {
        this.rf = this.q8.ac;
    };
    FinancialChart.prototype.xy = function (a, b) {
        this.a9 = this.q8.ai;
    };
    FinancialChart.prototype.xv = function (a, b) {
        this.ra = this.q8.y;
    };
    FinancialChart.prototype.x7 = function () {
        this.r1 = new IndicatorPane();
        this.rs = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.uj = a;
        this.ys();
        this.setGridRows();
        if (this.q8 != null) {
            this.q8.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.q8 != null) {
            this.q8.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.q8.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.ed;
        b.toolbarContainer = this.ug;
        b.legendContainer = this.uf;
        b.indicatorsContainer = this.ue;
        b.volumeContainer = this.uh;
        b.zoomContainer = this.ui;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.q8 == null) {
                this.q8 = new FinancialChartToolbar(this, this.u9);
            }
            this.q8.w.isIndicatorMenuVisible = this.sx && this.sy;
            this.ug = b.getSubRenderer(d);
            this.q8.l(this.ug);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.uf = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.ue = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.uh = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.ui = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.ug = null;
            if (this.q8 != null) {
                this.q8.l(null);
            }
            if (this.sq != null) {
                this.sq.provideContainer(null);
                this.sq = null;
            }
            if (this.rs != null) {
                this.rs.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.uh);
            }
            if (this.r1 != null) {
                this.r1.h(this.ue);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.ui);
                if (a != null) {
                    this.xf();
                }
                else {
                    this.sq = null;
                }
            }
            if (this.rs != null) {
                this.rs.provideContainer(this.uf);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.yi = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.yw = function (a, b) {
        this.yi(a, b, this.ui);
        if (b == null) {
            return;
        }
        this.xf();
    };
    FinancialChart.prototype.xf = function () {
        var _this = this;
        if (this.ui == null) {
            return;
        }
        if (this.sq != null) {
            this.sq.provideContainer(null);
        }
        this.sq = TypeRegistrar.create("ZoomSlider");
        this.sq.provideContainer(this.ui);
        var a = this.sq;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.o8 = new Rect(0, _this.sq.windowRect.left, _this.dataChart.os.top, _this.sq.windowRect.width, _this.dataChart.os.height);
            }
        });
        this.xg();
    };
    FinancialChart.prototype.yu = function (a, b) {
        this.yi(a, b, this.uh);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.uj == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.s6 ? this.t5 : 0) + "px";
        a[1] = this.s2 ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.sq != null) {
            if (a[5] == "0px") {
                this.sq.hide();
            }
            else {
                this.sq.show();
            }
        }
        this.uj.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, tslib_1.__spread([" "], a)), "auto", "1fr"));
        this.uj.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, tslib_1.__spread([" "], a)));
        if (this.ed == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.r1 != null) {
            this.r1.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.sq != null) {
            this.sq.notifySizeChanged();
        }
    };
    FinancialChart.prototype.hs = function () {
        _super.prototype.hs.call(this);
        this.jw = 3;
        this.o6 = 0;
        this.dp = NaN;
        this.dh = 30;
        this.b5 = true;
        this.cb = false;
        if (this.dataChart != null) {
            var a = this.dataChart.b8.j.e();
            this.qj = a.d;
            this.qk = a.e;
            this.qi = a.d;
            this.yy = this.dataChart.sj;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(139, 220, 92, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(139, 91, 177, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(109, 177, 255, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(115, 86, 86, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(140, 231, 217, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(168, 168, 183, .3)";
            return $ret;
        })()));
        this.ql = b;
        var c = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8bdc5c";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8b5bb1";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#6db1ff";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8ce7d9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#a8a8b7";
            return $ret;
        })()));
        this.qm = c;
    };
    FinancialChart.prototype.ye = function () {
        if (this.r1 != null) {
            this.r1.b = null;
            this.r1.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.yf = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.yo = function () {
        this.ye();
    };
    FinancialChart.prototype.xe = function () {
        if (this.sq == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.ed.rootWrapper.width();
        var b = this.dataChart.o7.left + this.dataChart.o7.width;
        var c = this.dataChart.o7.left;
        var d = a - b;
        this.sq.startInset = c - this.sq.trackStartInset;
        this.sq.endInset = d - this.sq.trackEndInset;
        if (this.sq.endInset < 0) {
            var e = this.sq.endInset;
            this.sq.endInset = 0;
            this.dataChart.fk += (e * -1);
        }
        if (this.sq.startInset < 0) {
            var f = this.sq.startInset;
            this.sq.startInset = 0;
            this.dataChart.fh += (f * -1);
        }
        this.zoomSliderChart.fh = c;
        this.zoomSliderChart.fk = d;
        this.zoomSliderChart.fd = this.sq.barExtent;
    };
    FinancialChart.prototype.x5 = function () {
        this.xe();
    };
    FinancialChart.prototype.hp = function (a) {
        _super.prototype.hp.call(this, a);
        if (a != null) {
            a.fc = 0;
        }
    };
    FinancialChart.prototype.yz = function (a) {
        return a.ol();
    };
    FinancialChart.prototype.y2 = function () {
        return this.uf == null ? null : this.y1(this.uf.rootWrapper);
    };
    FinancialChart.prototype.y0 = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.y1(a.d.rootWrapper);
    };
    FinancialChart.prototype.y1 = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.t1 = function () {
        if (this.uj == null) {
            return NaN;
        }
        var a = this.uj.getOffset();
        return this.uj.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.h0 = function (source_, a, b) {
        _super.prototype.h0.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jg(source_, a, b);
        }
    };
    FinancialChart.prototype.h1 = function (source_, a, b) {
        _super.prototype.h1.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jh(source_, a, b);
        }
    };
    FinancialChart.prototype.hz = function (source_) {
        _super.prototype.hz.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jd(source_);
        }
    };
    FinancialChart.prototype.h3 = function (source_, a, b, c) {
        _super.prototype.h3.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.ji(source_, a, b, c);
        }
    };
    FinancialChart.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        if (this.s3(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "q8", {
        get: function () {
            return this.q7;
        },
        set: function (a) {
            var b = this.q8;
            if (a != b) {
                this.q7 = a;
                this.id("Toolbar", b, this.q8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u8", {
        get: function () {
            return this.u1;
        },
        set: function (a) {
            var b = this.u8;
            if (a != b) {
                this.u1 = a;
                this.id("RangeSelectorTemplate", b, this.u8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u9", {
        get: function () {
            return this.u2;
        },
        set: function (a) {
            var b = this.u9;
            if (a != b) {
                this.u2 = a;
                this.id("ToolbarTemplate", b, this.u9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u5", {
        get: function () {
            return this.uy;
        },
        set: function (a) {
            var b = this.u5;
            if (a != b) {
                this.uy = a;
                this.id("ChartTypePickerTemplate", b, this.u5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "va", {
        get: function () {
            return this.u3;
        },
        set: function (a) {
            var b = this.va;
            if (a != b) {
                this.u3 = a;
                this.id("TrendLineTypePickerTemplate", b, this.va);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vb", {
        get: function () {
            return this.u4;
        },
        set: function (a) {
            var b = this.vb;
            if (a != b) {
                this.u4 = a;
                this.id("VolumeTypePickerTemplate", b, this.vb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u6", {
        get: function () {
            return this.uz;
        },
        set: function (a) {
            var b = this.u6;
            if (a != b) {
                this.uz = a;
                this.id("IndicatorMenuTemplate", b, this.u6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u7", {
        get: function () {
            return this.u0;
        },
        set: function (a) {
            var b = this.u7;
            if (a != b) {
                this.u0 = a;
                this.id("OverlayPickerTemplate", b, this.u7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sq", {
        get: function () {
            return this.sp;
        },
        set: function (a) {
            var b = this.sq;
            if (a != b) {
                this.sp = a;
                this.id("ZoomSlider", b, this.sq);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_dh = function () {
        return _super.prototype.get_dh.call(this);
    };
    FinancialChart.prototype.set_dh = function (a) {
        _super.prototype.set_dh.call(this, a);
    };
    FinancialChart.prototype.get_b5 = function () {
        return _super.prototype.get_b5.call(this);
    };
    FinancialChart.prototype.set_b5 = function (a) {
        _super.prototype.set_b5.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "t5", {
        get: function () {
            return this.tu;
        },
        set: function (a) {
            var b = this.t5;
            if (a != b) {
                this.tu = a;
                this.id("ToolbarHeight", b, this.t5);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.jp = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.jq = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.sq != null) {
            this.sq.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.sq != null) {
            this.sq.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.w = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_cl = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "cl", {
        get: function () {
            return this.get_cl();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_ck = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "ck", {
        get: function () {
            return this.get_ck();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.qu = function (a) {
        return this.qv(a);
    };
    FinancialChart.prototype.r8 = function (a) {
        return this.r9(a);
    };
    FinancialChart.prototype.qt = function (a) {
        var b = this.qu(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.hc = function () {
        this.xAxis = this.qt("xAxis");
        this.yAxis = this.r8(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.r8(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.qt("volumeXAxis");
        this.ti = new List$1(NumericYAxis.$, 0);
        this.tk = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.r8(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.qt("indicatorXAxis_0");
        this.ti.add(this.indicatorAxis);
        this.tk.add(this.indicatorXAxis);
        if (this.xAxis.ay == null) {
            this.xAxis.ay = new AxisLabelSettings();
        }
        if (this.yAxis.ay == null) {
            this.yAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeXAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorAxis.ay == null) {
            this.indicatorAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.ay == null) {
            this.indicatorXAxis.ay = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.r8(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.qt("zoomSliderXAxis");
        if (this.zoomSliderAxis.ay == null) {
            this.zoomSliderAxis.ay = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.ay == null) {
            this.zoomSliderXAxis.ay = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.ha = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.oi = this.aq(a, b);
        }
    };
    FinancialChart.prototype.iv = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.j2 = true;
            this.yAxis.kp = 10;
        }
    };
    FinancialChart.prototype.iy = function () {
        this.yAxis.j2 = this.tb;
        this.yAxis.kp = this.ux;
    };
    FinancialChart.prototype.rc = function (a) {
        var b;
        if (this.ra == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.ra;
        }
        b = this.rb(b);
        return b;
    };
    FinancialChart.prototype.rb = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.rl = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.re = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.vk = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.qv = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.r9 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.sf = function () {
        return this.az(1);
    };
    FinancialChart.prototype.sg = function () {
        return this.az(0);
    };
    FinancialChart.prototype.se = function () {
        return this.az(2);
    };
    FinancialChart.prototype.sh = function () {
        return this.az(20);
    };
    Object.defineProperty(FinancialChart.prototype, "sw", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rw", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sz", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ru", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sx", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ry", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sy", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r3", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.ay = function (a, b) {
        var c = this.vk(a);
        switch (this.rc(a)) {
            case 3:
                var d = this.sf();
                this.rw.setValueMemberPath(d, c);
                this.rw.setXAxis(d, this.xAxis);
                this.rw.setYAxis(d, this.yAxis);
                this.rw.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.sg();
                this.rw.setValueMemberPath(e, c);
                this.rw.setXAxis(e, this.xAxis);
                this.rw.setYAxis(e, this.yAxis);
                this.rw.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.sh();
                this.ru.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.ru.setHighMemberPath(f, a.getMemberPathFor(12));
                this.ru.setLowMemberPath(f, a.getMemberPathFor(13));
                this.ru.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.ru.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.ru.setXAxis(f, this.xAxis);
                this.ru.setYAxis(f, this.yAxis);
                this.ru.setDisplayType(f, this.ra == 1 ? 1 : 0);
                this.ru.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.ix = function () {
        _super.prototype.ix.call(this);
        this.x3(this.xAxis);
        this.yq(false);
        if (this.rf != 0 && this.volumeChart != null) {
            this.x9();
        }
        this.x3(this.volumeXAxis);
        this.x3(this.indicatorXAxis);
        this.yn();
        this.yp();
        if (this.rm != 0) {
            this.ya();
            this.x3(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.ou = function (a, b) {
        var e_1, _a;
        _super.prototype.ou.call(this, a, b);
        a(this.volumeXAxis);
        if (this.tk != null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.tk)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.oy = function (a, b) {
        var e_2, _a;
        _super.prototype.oy.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.ti != null) {
                try {
                    for (var _b = tslib_1.__values(fromEnum(this.ti)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.ow = function (a) {
        _super.prototype.ow.call(this, a);
        this.oo(this.volumeXAxis, a);
        this.oo(this.indicatorXAxis, a);
        this.oo(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.o0 = function (a) {
        _super.prototype.o0.call(this, a);
        this.oo(this.volumeAxis, a);
        this.oo(this.indicatorAxis, a);
        this.oo(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.oz = function (a) {
        _super.prototype.oz.call(this, a);
        this.on(this.volumeAxis, a);
        this.on(this.indicatorAxis, a);
        this.on(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.ov = function (a) {
        _super.prototype.ov.call(this, a);
        this.on(this.volumeXAxis, a);
        this.on(this.indicatorXAxis, a);
        this.on(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.ho = function (a) {
        var _this = this;
        _super.prototype.ho.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.py = a.p1 = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.pe = this.dataChart.pe;
                a.ph = this.dataChart.ph;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.we();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bw = 2;
    };
    FinancialChart.prototype.we = function () {
        if (this.vc == null) {
            FinancialChart.uw++;
            this.vc = FinancialChart.uw.toString();
        }
        return this.vc;
    };
    FinancialChart.prototype.xp = function (a, b) {
        this.xb();
        this.x5();
    };
    FinancialChart.prototype.xb = function () {
        var e_3, _a;
        if (this.yAxis.b1()) {
            return;
        }
        var a = this.yAxis.av.a6;
        if (this.rf != 0) {
            a = Math.max(a, this.volumeAxis.av.a6);
        }
        try {
            for (var _b = tslib_1.__values(fromEnum(this.ti)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.av.a6);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.xc(a);
    };
    FinancialChart.prototype.xc = function (a) {
        var e_4, _a;
        if (this.yAxis.b1()) {
            return;
        }
        this.yAxis.d7 = this.volumeAxis.d7 = a;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.ti)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.d7 = a;
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_4) throw e_4.error; }
        }
        this.zoomSliderAxis.d7 = this.yAxis.d7;
    };
    FinancialChart.prototype.xh = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.xk = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.xi = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.s3(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.xj = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.s3(d)) {
                continue;
            }
            var e = this.uq(d, c);
            a(d, e);
        }
        if (b) {
            this.xl(a);
        }
    };
    FinancialChart.prototype.xl = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.uq = function (a, b) {
        if (a.b4 != this.dataChart) {
            return b;
        }
        var c = this.x == null || this.x.dataSeries == null ? 0 : this.x.dataSeries.count;
        var d = this.rq == null ? 0 : this.rq.count;
        return b - (c * d);
    };
    FinancialChart.prototype.hi = function (a) {
        _super.prototype.hi.call(this, a);
        this.xk(a);
        this.xh(a);
        this.xl(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.sl;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.sl = a;
                this.id("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.x9 = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.s3(d) || d.cx) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.rf;
            f = this.re(f);
            switch (f) {
                case 2:
                    e = this.sg();
                    break;
                case 3:
                    e = this.se();
                    break;
                default:
                case 1:
                    e = this.sf();
                    break;
            }
            this.rw.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.rw.setXAxis(e, this.volumeXAxis);
            this.rw.setYAxis(e, this.volumeAxis);
            this.rw.setValueMemberPath(e, this.x != null && this.x.dataSeries != null && this.x.dataSeries.count > b ? this.x.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.gy = d.gy + " Volume";
            e.nb = ArrayExtension.getModulus$1(Brush.$, this.qn, b);
            e.ng = ArrayExtension.getModulus$1(Brush.$, this.qo, b);
            e.fv = this.t6;
            a.add(e);
        }
        var g = this.ch("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.ht(i, h);
        }
    };
    FinancialChart.prototype.s0 = function (a) {
        if (!this.sw) {
            return false;
        }
        return this.rw.matchesType(a);
    };
    FinancialChart.prototype.s4 = function (a) {
        if (!this.sz) {
            return false;
        }
        return this.ru.matchesType(a);
    };
    FinancialChart.prototype.s1 = function (a) {
        if (!this.sx) {
            return false;
        }
        return this.ry.matchesType(a);
    };
    FinancialChart.prototype.s3 = function (a) {
        if (!this.sy) {
            return false;
        }
        return this.r3.matchesType(a);
    };
    FinancialChart.prototype.x8 = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.ro == null ? 0 : this.ro.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.ro._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.s3(l) || l.cx) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.si("Custom");
                    this.ry.handleCustomIndicatorEvent(n, runOn(this, this.xn));
                    m = n;
                }
                else {
                    m = this.sk(this.ro._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.ry.setXAxis(m, this.tk._inner[e]);
                this.ry.setYAxis(m, this.ti._inner[e]);
                m.itemsSource = l.itemsSource;
                this.ry.setOpenMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(11));
                this.ry.setHighMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(12));
                this.ry.setLowMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(13));
                this.ry.setCloseMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(14));
                this.ry.setVolumeMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(15));
                m.gy = l.gy + " " + i;
                m.nb = ArrayExtension.getModulus$1(Brush.$, this.qh, e);
                m.fv = this.t3;
                if (this.s1(m)) {
                    this.ry.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.qi, e));
                    this.ry.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.r0, e));
                }
                if (this.us != -2147483648 && this.s1(m)) {
                    this.ry.setPeriodOverride(m, this.us);
                }
                if (this.s1(m)) {
                    this.ry.setSmoothingPeriod(m, this.uv);
                }
                if (this.s1(m)) {
                    this.ry.setSignalPeriod(m, this.uu);
                }
                if (this.s1(m)) {
                    this.ry.setShortPeriod(m, this.ut);
                    this.ry.setLongPeriod(m, this.ur);
                }
                this.ht(m, e);
                f.add(m);
            }
            var o = this.ch(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.ht(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.si = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.sk = function (a) {
        return this.si(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.yq = function (a) {
        if (this.q8 == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.q8.as = b.actualMinimumValue;
        this.q8.ar = b.actualMaximumValue;
        if (a) {
            this.q8.au = b.visibleMinimum;
            this.q8.at = b.visibleMaximum;
        }
        this.q8.bn();
    };
    FinancialChart.prototype.ee = function () {
        var e_5, _a, e_6, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.ee.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.qx();
            $ret.toolbar = _this.q8 == null ? null : _this.q8.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.qx();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = tslib_1.__values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.qx());
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_5) throw e_5.error; }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.yz(this.dataChart).x;
            a.mainChartTop = this.yz(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.yz(this.volumeChart).x;
            a.volumeChartTop = this.yz(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.yz(this.zoomSliderChart).x;
            a.zoomChartTop = this.yz(this.zoomSliderChart).y;
        }
        if (this.q8 != null) {
            var c = this.y0(this.q8);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = tslib_1.__values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.yz(d).x);
                    a.indicatorChartTops.add(this.yz(d).y);
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_6) throw e_6.error; }
            }
        }
        var e = this.y2();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.rs == null ? null : this.rs.exportVisualData();
        return a;
    };
    FinancialChart.prototype.vh = function () {
        var a = this.ee();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.sj = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.yp = function () {
        var e_7, _a, e_8, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = tslib_1.__values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.s3(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_7) throw e_7.error; }
        }
        try {
            for (var _e = tslib_1.__values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_8) throw e_8.error; }
        }
        if (this.rq == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.s3(g) || g.cx) {
                continue;
            }
            e++;
            for (var h = 0; h < this.rq.count; h++) {
                var i = this.rq._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.sj(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.sj(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.r3.setXAxis(j, this.xAxis);
                this.r3.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.rq.count + h;
                j.nb = ArrayExtension.getModulus$1(Brush.$, this.ql, k);
                j.ng = ArrayExtension.getModulus$1(Brush.$, this.qm, k);
                j.fv = this.t4;
                j.gy = g.gy + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.x.dataSeries._inner[e];
                this.r3.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.r3.setHighMemberPath(j, m.getMemberPathFor(12));
                this.r3.setLowMemberPath(j, m.getMemberPathFor(13));
                this.r3.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.r3.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].gi = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.ht(q, p);
        }
    };
    FinancialChart.prototype.yn = function () {
        var e_9, _a;
        if (this.s9) {
            return;
        }
        this.s9 = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = tslib_1.__values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.x4(b);
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_9) throw e_9.error; }
            }
        }
        if ((this.ro == null || this.ro.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.ti != null) {
                this.ti.clear();
            }
            if (this.tk != null) {
                this.tk.clear();
            }
            this.ye();
            this.yo();
            this.s9 = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.ti.clear();
        this.tk.clear();
        var c = this.ro == null ? 0 : this.ro.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.x2(g);
            var h = f >= c;
            if (h) {
                g.hy = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.hy = this.vj(this.ro._inner[f]);
            }
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b7) {
                        j = this.qu(0);
                    }
                    else {
                        j = this.qu(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.ti.add(i);
                this.tk.add(j);
                if (this.bw) {
                    this.or(i);
                }
                if (this.bw) {
                    this.op(j);
                }
            }
        }
        this.x8();
        this.ye();
        if (this.q8 != null) {
            this.q8.ae = this.ro;
        }
        this.xd();
        this.yo();
        this.s9 = false;
    };
    FinancialChart.prototype.hl = function () {
        var e_10, _a, e_11, _b;
        _super.prototype.hl.call(this);
        this.op(this.xAxis);
        this.op(this.volumeXAxis);
        if (this.tk != null) {
            try {
                for (var _c = tslib_1.__values(fromEnum(this.tk)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.op(a);
                }
            }
            catch (e_10_1) { e_10 = { error: e_10_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_10) throw e_10.error; }
            }
        }
        this.or(this.yAxis);
        this.or(this.volumeAxis);
        if (this.ti != null) {
            try {
                for (var _e = tslib_1.__values(fromEnum(this.ti)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.or(b);
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_11) throw e_11.error; }
            }
        }
        this.op(this.zoomSliderXAxis);
        this.or(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_ca = function () {
        return !this.s7;
    };
    Object.defineProperty(FinancialChart.prototype, "td", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.yv = function (a, b) {
        this.yh(a, b);
        this.xd();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.ya();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.yf();
        this.yw(a, b);
    };
    FinancialChart.prototype.ya = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.s3(c) || c.cx) {
                continue;
            }
            var d = void 0;
            var e = this.rm;
            e = this.rl(e);
            var f = this.uq(c, b);
            if (e == 1) {
                switch (this.rc(this.x != null && this.x.dataSeries != null && this.x.dataSeries.count > f ? this.x.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.sh();
                    this.ru.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.sh();
                    this.ru.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.sg();
                    break;
                case 6:
                    d = this.se();
                    break;
                default:
                case 4:
                    d = this.sf();
                    break;
            }
            var g = this.x != null && this.x.dataSeries != null && this.x.dataSeries.count > f ? this.x.dataSeries._inner[f] : null;
            if (d.cz && !d.c6) {
                this.rw.setCategoryMode(d, 1);
                this.rw.setXAxis(d, this.zoomSliderXAxis);
                this.rw.setYAxis(d, this.zoomSliderAxis);
                this.rw.setValueMemberPath(d, g == null ? null : this.vk(g));
            }
            else if (d.c6) {
                this.ru.setCategoryMode(d, 1);
                this.ru.setXAxis(d, this.zoomSliderXAxis);
                this.ru.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.ru.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.ru.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.ru.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.ru.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.ru.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.gy = c.gy;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.ht(i, h);
        }
    };
    FinancialChart.prototype.h8 = function (a, b, c) {
        var e_12, _a;
        _super.prototype.h8.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_12_1) { e_12 = { error: e_12_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_12) throw e_12.error; }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.xn = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.b4);
        }
        e -= this.ro == null ? 0 : this.ro.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.yj = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.bw) {
            this.op(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "tc", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.xo = function (a, b) {
        this.yn();
    };
    FinancialChart.prototype.s5 = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.yd = function () {
        var e_13, _a;
        var a = this.q6 != null ? this.q6 : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = tslib_1.__values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.s5(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_13) throw e_13.error; }
        }
        this.q5 = b;
        if (this.q8 != null) {
            this.q8.u = this.q5;
        }
    };
    FinancialChart.prototype.xs = function (a, b) {
        this.yd();
    };
    FinancialChart.prototype.xx = function (a, b) {
        this.rq = this.q8.ag;
    };
    FinancialChart.prototype.xw = function (a, b) {
        this.ro = this.q8.ae;
    };
    FinancialChart.prototype.xq = function (a, b) {
        this.yn();
    };
    FinancialChart.prototype.xr = function (a, b) {
        this.yp();
    };
    FinancialChart.prototype.x1 = function (a, b) {
        var c = a;
        if (c.bf == null) {
            return;
        }
        if (this.s7) {
            this.yc(c.bf);
        }
    };
    FinancialChart.prototype.x4 = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.xp));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d7 = this.volumeAxis.d7 = this.indicatorAxis.d7 = 0;
            this.xAxis.ay.visibility = this.p7;
        }
    };
    FinancialChart.prototype.x2 = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.o8 = new Rect(0, this.dataChart.os.x, a.o8.y, this.dataChart.os.width, a.o8.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.xp));
        this.hn(a);
    };
    FinancialChart.prototype.xd = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.on(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.tk._inner[a];
            var c = a < this_1.tk.count - 1 || this_1.volumeChart != null;
            this_1.on(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.tk.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.yh = function (a, b) {
        if (a != null) {
            this.x4(a);
        }
        if (b != null) {
            this.x2(b);
        }
    };
    FinancialChart.prototype.yt = function (a, b) {
        this.yh(a, b);
        this.xd();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.x9();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.yu(a, b);
    };
    FinancialChart.prototype.xt = function (a, b) {
        this.yr();
    };
    FinancialChart.prototype.yr = function () {
        if (this.q8 == null || +(this.q8.au) == +(dateMaxValue()) || +(this.q8.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.q8.au, this.q8.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.s8 = true;
        this.dataChart.o8 = new Rect(0, b.left, this.dataChart.o8.top, b.width, this.dataChart.o8.height);
        if (this.sq != null) {
            this.sq.windowRect = this.dataChart.os;
        }
        if (this.s7) {
            this.yc(this.dataChart);
        }
        this.s8 = false;
    };
    FinancialChart.prototype.x0 = function (a, b) {
        this.yd();
        this.yq(!this.s8);
    };
    FinancialChart.prototype.xm = function (a, b) {
        var _this = this;
        if (!this.s8) {
            if (this.s7) {
                this.yc(a);
            }
            var c = false;
            var d = this.ij(function () { return _this.yq(true); }, c);
            c = d.p1;
            if (this.sq != null) {
                this.sq.windowRect = this.dataChart.os;
            }
        }
    };
    FinancialChart.prototype.yl = function (a, b, c, d) {
        var e_14, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.s8 = true;
            a.o8 = new Rect(0, d, a.os.top, c, a.os.height);
            this.s8 = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.ca, a.ow);
        try {
            for (var _b = tslib_1.__values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.fa();
                var j = i.ap(a.os);
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.dz(j.c, h);
                var m = b.dz(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_14_1) { e_14 = { error: e_14_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_14) throw e_14.error; }
        }
        var n = a.os.width;
        if (c != -1) {
            n = c;
        }
        var o = a.os.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.s8 = true;
        var p = new Rect(0, o, e, n, f - e);
        a.o8 = p;
        this.s8 = false;
    };
    FinancialChart.prototype.yk = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.yl(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.yl(this.volumeChart, this.volumeAxis, this.dataChart.os.width, this.dataChart.os.left);
            }
        }
        else if (a == this.volumeChart) {
            this.yl(this.volumeChart, this.volumeAxis, -1, -1);
            this.yl(this.dataChart, this.yAxis, this.volumeChart.os.width, this.volumeChart.os.left);
        }
    };
    FinancialChart.prototype.yc = function (a) {
        var _this = this;
        this.ii(function () { return _this.yk(a); });
    };
    FinancialChart.prototype.xu = function (a, b) {
        if (this.s7) {
            this.yc(a);
        }
    };
    FinancialChart.prototype.ys = function () {
        if (!this.td) {
            return;
        }
        this.xg();
        if (this.rm == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.ya();
        }
    };
    FinancialChart.prototype.xg = function () {
        var container_ = this.ui.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.sq != null && containerParent_ != null && !this.te) {
            this.te = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.sq;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.ym = function () {
        var _this = this;
        if (this.rh != 1) {
            return;
        }
        this.ot(function (a) {
            var e_15, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = tslib_1.__values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_15_1) { e_15 = { error: e_15_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_15) throw e_15.error; }
            }
        });
    };
    FinancialChart.prototype.i2 = function (a, b, c) {
        _super.prototype.i2.call(this, a, b, c);
        if (this.x.dataSeries.count > 0) {
            if (this.rh == 1 && stringIsNullOrEmpty(this.e6)) {
                this.ae.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.e8)) {
                this.ae.setYMemberPath(a, this.vk(c));
            }
            if (stringIsNullOrEmpty(this.e2)) {
                this.ae.setLabelMemberPath(a, this.vk(c));
            }
            if (stringIsNullOrEmpty(this.ez)) {
                this.ae.setContentMemberPath(a, this.vk(c));
            }
        }
    };
    FinancialChart.prototype.vj = function (a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    };
    FinancialChart.prototype.op = function (a) {
        var e_16, _a;
        _super.prototype.op.call(this, a);
        var b = a;
        this.x3(b);
        if (a.bf != null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.s0(c)) {
                        this.rw.setXAxis(c, b);
                    }
                    else if (this.s4(c)) {
                        this.ru.setXAxis(c, b);
                    }
                    else if (this.s1(c)) {
                        this.ry.setXAxis(c, b);
                    }
                    else if (this.s3(c)) {
                        this.r3.setXAxis(c, b);
                    }
                }
            }
            catch (e_16_1) { e_16 = { error: e_16_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_16) throw e_16.error; }
            }
        }
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.it = this.yy;
            a.d6 = this.ud;
            this.on(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.tq;
        e.maximumValue = this.tp;
    };
    FinancialChart.prototype.or = function (a) {
        var e_17, _a;
        _super.prototype.or.call(this, a);
        if (a.bf != null && a == this.yAxis) {
            try {
                for (var _b = tslib_1.__values(fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.s0(b)) {
                        this.rw.setYAxis(b, this.yAxis);
                    }
                    else if (this.s4(b)) {
                        this.ru.setYAxis(b, this.yAxis);
                    }
                    else if (this.s1(b)) {
                        this.ry.setYAxis(b, this.yAxis);
                    }
                    else if (this.s3(b)) {
                        this.r3.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_17_1) { e_17 = { error: e_17_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_17) throw e_17.error; }
            }
        }
        a.jx = this.ta;
        a.kl = this.ub;
        a.kk = this.ua;
        if (a == this.yAxis) {
            a.kh = this.t9;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.on(a, function (d) { return d.visibility = 1; });
        }
    };
    FinancialChart.prototype.x3 = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.fa = XYChart.md(a, this.x.dataSeries);
        if (this.x.dataSeries.count > 0) {
            var b = this.x.dataSeries._inner[0].getMemberPathFor(17);
            a.g2(b);
        }
    };
    FinancialChart.prototype.ht = function (a, b) {
        _super.prototype.ht.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.zoomSliderChart == a.b4;
        var d = this.dataChart != null && this.dataChart.series.contains(a);
        if ((d || c) && a.de) {
            a.k8(this.qj != null ? ArrayExtension.getModulus$1(Brush.$, this.qj, b) : null, this.qk != null ? ArrayExtension.getModulus$1(Brush.$, this.qk, b) : null);
        }
        var e = this.s1(a);
        if (this.s3(a)) {
            a.nb = this.ql != null ? ArrayExtension.getModulus$1(Brush.$, this.ql, b) : null;
            a.ng = this.qm != null ? ArrayExtension.getModulus$1(Brush.$, this.qm, b) : null;
            a.fv = this.t4;
        }
        else if (e) {
            a.nb = this.qh != null ? ArrayExtension.getModulus$1(Brush.$, this.qh, b) : null;
            a.fv = this.t3;
        }
        else if (!a.cx && (d || c)) {
            a.nb = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.ng = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.b4;
        if (f) {
            a.fv = this.t6;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.s2 ? this.rs : null;
    };
    FinancialChart.prototype.id = function (a, b, c) {
        var e_18, _a, e_19, _b;
        var _this = this;
        _super.prototype.id.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.j2 = this.tb;
                if (this.volumeAxis != null) {
                    this.volumeAxis.j2 = this.tb;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.j2 = this.tb;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.kp = this.ux;
                if (this.volumeAxis != null) {
                    this.volumeAxis.kp = this.ux;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.kp = this.ux;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.rf == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.x9();
                }
                break;
            case "VolumeChart":
                this.yt(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.xp));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.xm));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.xu));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.xp));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.xm));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.xu));
                }
                this.ys();
                break;
            case "XAxisMode":
                this.xAxis = this.qu(this.rh);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.qu(this.rh);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.qu(this.rh);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.qu(this.rh);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.on(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.xd();
                if (this.rh == 1) {
                    this.ym();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.r8(this.rj);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.r8(this.rj);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.r8(this.rj);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.xt));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.xw));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.xx));
                }
                if (this.q8 != null) {
                    this.q8.ae = this.ro;
                    this.q8.ag = this.rq;
                    this.q8.u = this.q5;
                    this.yq(true);
                    var j = this.q8;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.xt));
                    var k = this.q8;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.xw));
                    var l = this.q8;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.xx));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.x0));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.bw) {
                    this.op(this.xAxis);
                    this.hg();
                }
                this.yq(false);
                this.yr();
                this.yd();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.x0));
                break;
            case "ChartType":
                this.ix();
                break;
            case "VolumeXAxis":
                this.yj(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.yj(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.yn();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.bw) {
                    this.or(this.yAxis);
                    this.or(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.x1));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.x9();
                }
                if (this.bw) {
                    this.or(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.x1));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_18 = void 0, tslib_1.__values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_18_1) { e_18 = { error: e_18_1 }; }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                            }
                            finally { if (e_18) throw e_18.error; }
                        }
                        try {
                            for (var _e = (e_19 = void 0, tslib_1.__values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_19_1) { e_19 = { error: e_19_1 }; }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                            }
                            finally { if (e_19) throw e_19.error; }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.rj == 1) {
                            y = this.r8(this.rj);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.bw) {
                            this.or(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.p1 = this.cb && this.ca;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.p1 = this.cb && this.ca;
                }
                if (this.s7) {
                    this.yk(this.dataChart);
                }
                else {
                    this.volumeChart.qv = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.xq));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.xq));
                }
                this.yn();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.xr));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.xr));
                }
                this.yp();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.ox(function (ad) { return ad.jx = _this.ta; });
                break;
            case "YAxisMinimumValue":
                this.oy(function (ad) { return ad.kl = _this.ub; }, false);
                break;
            case "YAxisMaximumValue":
                this.oy(function (ad) { return ad.kk = _this.ua; }, false);
                break;
            case "YAxisInterval":
                this.oy(function (ad) { return ad.kh = _this.t9; }, false);
                break;
            case "ZoomSliderType":
                this.ys();
                break;
            case "ZoomSliderChart":
                if (!this.tc) {
                    return;
                }
                this.yv(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.xj(function (ad, ae) {
                    if (ad.de) {
                        ad.k8(_this.qj != null ? ArrayExtension.getModulus$1(Brush.$, _this.qj, ae) : null, _this.qk != null ? ArrayExtension.getModulus$1(Brush.$, _this.qk, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.hi(function (ad, ae) {
                    if (!(_this.s3(ad))) {
                        return;
                    }
                    ad.nb = _this.ql != null ? ArrayExtension.getModulus$1(Brush.$, _this.ql, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.hi(function (ad, ae) {
                    if (!(_this.s3(ad))) {
                        return;
                    }
                    ad.ng = _this.qm != null ? ArrayExtension.getModulus$1(Brush.$, _this.qm, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.hi(function (ad, ae) {
                    if (!(_this.s3(ad))) {
                        return;
                    }
                    ad.fv = _this.t4;
                });
                break;
            case "VolumeBrushes":
                this.xk(function (ad, ae) { return ad.nb = ArrayExtension.getModulus$1(Brush.$, _this.qn, ae); });
                break;
            case "VolumeOutlines":
                this.xk(function (ad, ae) { return ad.ng = ArrayExtension.getModulus$1(Brush.$, _this.qo, ae); });
                break;
            case "VolumeThickness":
                this.xk(function (ad, ae) { return ad.fv = _this.t6; });
                break;
            case "IndicatorNegativeBrushes":
                this.xh(function (ad, ae) { return _this.ry.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.qi, ae)); });
                break;
            case "IndicatorBrushes":
                this.xh(function (ad, ae) { return ad.nb = ArrayExtension.getModulus$1(Brush.$, _this.qh, ae); });
                break;
            case "IndicatorThickness":
                this.xh(function (ad, ae) { return ad.fv = _this.t3; });
                break;
            case "IndicatorDisplayTypes":
                this.xh(function (ad, ae) { return _this.ry.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.r0, ae)); });
                break;
            case "IndicatorPeriod":
                this.xh(function (ad, ae) {
                    if (_this.us == -2147483648 || !(_this.s1(ad))) {
                        return;
                    }
                    _this.ry.setPeriodOverride(ad, _this.us);
                });
                break;
            case "IndicatorMultiplier":
                this.xh(function (ad, ae) {
                    if (!(_this.s3(ad))) {
                        return;
                    }
                    _this.r3.setMultiplier(ad, _this.t2);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.xh(function (ad, ae) {
                    if (!(_this.s1(ad))) {
                        return;
                    }
                    _this.ry.setSmoothingPeriod(ad, _this.uv);
                });
                break;
            case "IndicatorShortPeriod":
                this.xh(function (ad, ae) {
                    if (!(_this.s1(ad))) {
                        return;
                    }
                    _this.ry.setShortPeriod(ad, _this.ut);
                });
                break;
            case "IndicatorLongPeriod":
                this.xh(function (ad, ae) {
                    if (!(_this.s1(ad))) {
                        return;
                    }
                    _this.ry.setLongPeriod(ad, _this.ur);
                });
                break;
            case "IndicatorSignalPeriod":
                this.xh(function (ad, ae) {
                    if (!(_this.s1(ad))) {
                        return;
                    }
                    _this.ry.setSignalPeriod(ad, _this.uu);
                });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.xs));
                }
                if (this.q6 != null) {
                    var ae = this.q6;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.xs));
                }
                this.yd();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.xo));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.xo));
                }
                this.yn();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.xj(function (ah, ai) { return ah.nb = _this.j != null ? ArrayExtension.getModulus$1(Brush.$, _this.j, ai) : null; }, true);
                break;
            case "Outlines":
                this.xj(function (ah, ai) { return ah.ng = _this.n != null ? ArrayExtension.getModulus$1(Brush.$, _this.n, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.p7 == 0 && this.zoomSliderXAxis != null) {
                    this.on(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.xd();
                break;
            case "YAxisLabelVisibility":
                if (this.p8 != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.on(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.it = this.yy;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d6 = this.ud;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.s2 && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.rs : null;
                        }
                    };
                    this.xj(ai, false);
                    this.xi(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.ya();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.bw) {
                        this.or(this.zoomSliderAxis);
                    }
                    this.on(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.ot(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.tq;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.ot(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.tp;
                    }
                });
                break;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "tb", {
        get: function () {
            return this.sv;
        },
        set: function (a) {
            var b = this.tb;
            if (a != b) {
                this.sv = a;
                this.id("YAxisIsLogarithmic", b, this.tb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ux", {
        get: function () {
            return this.up;
        },
        set: function (a) {
            var b = this.ux;
            if (a != b) {
                this.up = a;
                this.id("YAxisLogarithmBase", b, this.ux);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t9", {
        get: function () {
            return this.tw;
        },
        set: function (a) {
            var b = this.t9;
            if (a != b) {
                this.tw = a;
                this.id("YAxisInterval", b, this.t9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ub", {
        get: function () {
            return this.ty;
        },
        set: function (a) {
            var b = this.ub;
            if (a != b) {
                this.ty = a;
                this.id("YAxisMinimumValue", b, this.ub);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ua", {
        get: function () {
            return this.tx;
        },
        set: function (a) {
            var b = this.ua;
            if (a != b) {
                this.tx = a;
                this.id("YAxisMaximumValue", b, this.ua);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "uc", {
        get: function () {
            return this.tz;
        },
        set: function (a) {
            var b = this.uc;
            if (a != b) {
                this.tz = a;
                this.id("YAxisMinorInterval", b, this.uc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t8", {
        get: function () {
            return this.yAxis.kd;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t7", {
        get: function () {
            return this.yAxis.kc;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rf", {
        get: function () {
            return this.rd;
        },
        set: function (a) {
            var b = this.rf;
            if (a != b) {
                this.rd = a;
                this.id("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.rf));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rh", {
        get: function () {
            return this.rg;
        },
        set: function (a) {
            var b = this.rh;
            if (a != b) {
                this.rg = a;
                this.id("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.rh));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rj", {
        get: function () {
            return this.ri;
        },
        set: function (a) {
            var b = this.rj;
            if (a != b) {
                this.ri = a;
                this.id("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.rj));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s6", {
        get: function () {
            return this.ss;
        },
        set: function (a) {
            var b = this.s6;
            if (a != b) {
                this.ss = a;
                this.id("IsToolbarVisible", b, this.s6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ra", {
        get: function () {
            return this.q9;
        },
        set: function (a) {
            var b = this.ra;
            if (a != b) {
                this.q9 = a;
                this.id("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ra));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_o6 = function () {
        return _super.prototype.get_o6.call(this);
    };
    FinancialChart.prototype.set_o6 = function (a) {
        _super.prototype.set_o6.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "s7", {
        get: function () {
            return this.st;
        },
        set: function (a) {
            var b = this.s7;
            if (a != b) {
                this.st = a;
                this.id("IsWindowSyncedToVisibleRange", b, this.s7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ro", {
        get: function () {
            return this.rn;
        },
        set: function (a) {
            var b = this.ro;
            if (a != b) {
                this.rn = a;
                this.id("IndicatorTypes", b, this.ro);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rq", {
        get: function () {
            return this.rp;
        },
        set: function (a) {
            var b = this.rq;
            if (a != b) {
                this.rp = a;
                this.id("OverlayTypes", b, this.rq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.tg;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.tg = a;
                this.id("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ta", {
        get: function () {
            return this.su;
        },
        set: function (a) {
            var b = this.ta;
            if (a != b) {
                this.su = a;
                this.id("YAxisAbbreviateLargeNumbers", b, this.ta);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_dp = function () {
        return _super.prototype.get_dp.call(this);
    };
    FinancialChart.prototype.set_dp = function (a) {
        _super.prototype.set_dp.call(this, a);
    };
    FinancialChart.prototype.get_jw = function () {
        return _super.prototype.get_jw.call(this);
    };
    FinancialChart.prototype.set_jw = function (a) {
        _super.prototype.set_jw.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.sm;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.sm = a;
                this.id("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.r7;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.r7 = a;
                this.id("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.qs;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.qs = a;
                this.id("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rm", {
        get: function () {
            return this.rk;
        },
        set: function (a) {
            var b = this.rm;
            if (a != b) {
                this.rk = a;
                this.id("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.rm));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qj", {
        get: function () {
            return this.qb;
        },
        set: function (a) {
            var b = this.qj;
            if (a != b) {
                this.qb = a;
                this.id("NegativeBrushes", b, this.qj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qk", {
        get: function () {
            return this.qc;
        },
        set: function (a) {
            var b = this.qk;
            if (a != b) {
                this.qc = a;
                this.id("NegativeOutlines", b, this.qk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ql", {
        get: function () {
            return this.qd;
        },
        set: function (a) {
            var b = this.ql;
            if (a != b) {
                this.qd = a;
                this.id("OverlayBrushes", b, this.ql);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qm", {
        get: function () {
            return this.qe;
        },
        set: function (a) {
            var b = this.qm;
            if (a != b) {
                this.qe = a;
                this.id("OverlayOutlines", b, this.qm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qo", {
        get: function () {
            return this.qg;
        },
        set: function (a) {
            var b = this.qo;
            if (a != b) {
                this.qg = a;
                this.id("VolumeOutlines", b, this.qo);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qn", {
        get: function () {
            return this.qf;
        },
        set: function (a) {
            var b = this.qn;
            if (a != b) {
                this.qf = a;
                this.id("VolumeBrushes", b, this.qn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qi", {
        get: function () {
            return this.qa;
        },
        set: function (a) {
            var b = this.qi;
            if (a != b) {
                this.qa = a;
                this.id("IndicatorNegativeBrushes", b, this.qi);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qh", {
        get: function () {
            return this.p9;
        },
        set: function (a) {
            var b = this.qh;
            if (a != b) {
                this.p9 = a;
                this.id("IndicatorBrushes", b, this.qh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t6", {
        get: function () {
            return this.tv;
        },
        set: function (a) {
            var b = this.t6;
            if (a != b) {
                this.tv = a;
                this.id("VolumeThickness", b, this.t6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t4", {
        get: function () {
            return this.tt;
        },
        set: function (a) {
            var b = this.t4;
            if (a != b) {
                this.tt = a;
                this.id("OverlayThickness", b, this.t4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t3", {
        get: function () {
            return this.ts;
        },
        set: function (a) {
            var b = this.t3;
            if (a != b) {
                this.ts = a;
                this.id("IndicatorThickness", b, this.t3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r0", {
        get: function () {
            return this.rz;
        },
        set: function (a) {
            var b = this.r0;
            if (a != b) {
                this.rz = a;
                this.id("IndicatorDisplayTypes", b, this.r0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "us", {
        get: function () {
            return this.ul;
        },
        set: function (a) {
            var b = this.us;
            if (a != b) {
                this.ul = a;
                this.id("IndicatorPeriod", b, this.us);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t2", {
        get: function () {
            return this.tr;
        },
        set: function (a) {
            var b = this.t2;
            if (a != b) {
                this.tr = a;
                this.id("IndicatorMultiplier", b, this.t2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "uv", {
        get: function () {
            return this.uo;
        },
        set: function (a) {
            var b = this.uv;
            if (a != b) {
                this.uo = a;
                this.id("IndicatorSmoothingPeriod", b, this.uv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ut", {
        get: function () {
            return this.um;
        },
        set: function (a) {
            var b = this.ut;
            if (a != b) {
                this.um = a;
                this.id("IndicatorShortPeriod", b, this.ut);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ur", {
        get: function () {
            return this.uk;
        },
        set: function (a) {
            var b = this.ur;
            if (a != b) {
                this.uk = a;
                this.id("IndicatorLongPeriod", b, this.ur);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "uu", {
        get: function () {
            return this.un;
        },
        set: function (a) {
            var b = this.uu;
            if (a != b) {
                this.un = a;
                this.id("IndicatorSignalPeriod", b, this.uu);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q6", {
        get: function () {
            return this.q4;
        },
        set: function (a) {
            var b = this.q6;
            if (a != b) {
                this.q4 = a;
                this.id("RangeSelectorOptions", b, this.q6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.q0;
        },
        set: function (a) {
            var b = this.q0;
            if (a != b) {
                this.q0 = a;
                this.id("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_cb = function () {
        return _super.prototype.get_cb.call(this);
    };
    FinancialChart.prototype.set_cb = function (a) {
        _super.prototype.set_cb.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "yy", {
        get: function () {
            return this.yx;
        },
        set: function (a) {
            var b = this.yy;
            if (a != b) {
                this.yx = a;
                this.id("ZoomSliderXAxisMajorStroke", b, this.yy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ud", {
        get: function () {
            return this.t0;
        },
        set: function (a) {
            var b = this.ud;
            if (a != b) {
                this.t0 = a;
                this.id("ZoomSliderXAxisMajorStrokeThickness", b, this.ud);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s2", {
        get: function () {
            return this.sr;
        },
        set: function (a) {
            var b = this.s2;
            if (a != b) {
                this.sr = a;
                this.id("IsLegendVisible", b, this.s2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rs", {
        get: function () {
            return this.rr;
        },
        set: function (a) {
            var b = this.rs;
            if (a != b) {
                this.rr = a;
                this.id("FinancialChartLegend", b, this.rs);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.qr;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.qr = a;
                this.id("XAxis", b, this.xAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.r6;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.r6 = a;
                this.id("YAxis", b, this.yAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.r5;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.r5 = a;
                this.id("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.qq;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.qq = a;
                this.id("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.r4;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.r4 = a;
                this.id("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.qp;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.qp = a;
                this.id("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ti", {
        get: function () {
            return this.tf;
        },
        set: function (a) {
            var b = this.ti;
            if (a != b) {
                this.tf = a;
                this.id("IndicatorAxes", b, this.ti);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tk", {
        get: function () {
            return this.th;
        },
        set: function (a) {
            var b = this.tk;
            if (a != b) {
                this.th = a;
                this.id("IndicatorXAxes", b, this.tk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tq", {
        get: function () {
            return this.to;
        },
        set: function (a) {
            var b = this.tq;
            if (+a != +b) {
                this.to = a;
                this.id("XAxisMinimumValue", b, this.tq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tp", {
        get: function () {
            return this.tn;
        },
        set: function (a) {
            var b = this.tp;
            if (+a != +b) {
                this.tn = a;
                this.id("XAxisMaximumValue", b, this.tp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.tl;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.uw = 0;
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.u8 : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.u5 : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.u6 : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_20, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = tslib_1.__values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_20_1) { e_20 = { error: e_20_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_20) throw e_20.error; }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        _this.p.c = _this.q;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.f(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.d(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.ao();
        }
        if (this.p != null) {
            this.p.i(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
//# sourceMappingURL=FinancialChart_combined.js.map