/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point_$type, runOn, typeCast, markType, markDep } from "igniteui-angular-core";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
var HorizontalRangeCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(HorizontalRangeCategorySeries, _super);
    function HorizontalRangeCategorySeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalRangeCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    HorizontalRangeCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    HorizontalRangeCategorySeries.prototype.ji = function () {
        _super.prototype.ji.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalRangeCategorySeries.prototype.ah = function (a) {
        var b = this.aj(this.pu(), this.pv.f, this.qu(this.bs), this.qv(this.bs), this.nw(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.ai = function (a) {
        var b = this.aj(this.pu(), this.pv.f, this.qu(this.bs), this.qv(this.bs), this.nw(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.get_di = function () {
        return true;
    };
    HorizontalRangeCategorySeries.prototype.bj = function () {
        if (this.bk == 0) {
            return 1;
        }
        else {
            return _super.prototype.bj.call(this);
        }
    };
    HorizontalRangeCategorySeries.prototype.getOffsetValue = function () {
        return this.RangeFramePreparer.r(this.xAxis, this.bs.bv, this.bs.bu, this.getEffectiveViewport1(this.bs));
    };
    HorizontalRangeCategorySeries.prototype.getCategoryWidth = function () {
        return this.xAxis.getCategorySize(this.bs.bv, this.bs.bu, this.getEffectiveViewport1(this.bs));
    };
    HorizontalRangeCategorySeries.prototype.gd = function (a, b) {
        return this.ge(a, b, this.xAxis, runOn(this, this.qs), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.gf = function (a, b) {
        return this.gg(a, b, this.xAxis, runOn(this, this.qs), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.e2 = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.xAxis.j8;
        return this.e3(a, b, this.xAxis, d, e, f, runOn(this, this.qs));
    };
    HorizontalRangeCategorySeries.prototype.fh = function (a, b, c) {
        if (this.b6 == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bs);
        var e = new ScalerParams(0, this.b6.os, this.bs.bu, this.xAxis.ca, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.b6.os, this.bs.bu, d);
        return this.fj(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.qs), b, c);
    };
    HorizontalRangeCategorySeries.prototype.ff = function (a, b, c) {
        if (this.b6 == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bs);
        var e = new ScalerParams(0, this.b6.os, this.bs.bu, this.xAxis.ca, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.b6.os, this.bs.bu, d);
        return this.fj(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.qs), b, c);
    };
    HorizontalRangeCategorySeries.prototype.fd = function (a, b, c) {
        if (this.b6 == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bs);
        var e = new ScalerParams(0, this.b6.os, this.bs.bu, this.xAxis.ca, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.b6.os, this.bs.bu, d);
        return this.fj(this.highColumn, a, this.xAxis, e, f, runOn(this, this.qs), b, c);
    };
    HorizontalRangeCategorySeries.prototype.np = function (a, b, c) {
        var _this = this;
        return this.nv(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bs.bv, this.bs.bu, this.getEffectiveViewport1(this.bs)), this.yAxis, this.xAxis, runOn(this, this.fd), function (d, e) { return _this.gg(d, e, _this.xAxis, runOn(_this, _this.qs), _this.highColumn); }, function (d, e) { return _this.ge(d, e, _this.xAxis, runOn(_this, _this.qs), _this.highColumn); });
    };
    HorizontalRangeCategorySeries.prototype.nr = function (a, b, c) {
        var _this = this;
        return this.nv(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bs.bv, this.bs.bu, this.getEffectiveViewport1(this.bs)), this.yAxis, this.xAxis, runOn(this, this.ff), function (d, e) { return _this.gg(d, e, _this.xAxis, runOn(_this, _this.qs), _this.lowColumn); }, function (d, e) { return _this.ge(d, e, _this.xAxis, runOn(_this, _this.qs), _this.lowColumn); });
    };
    HorizontalRangeCategorySeries.prototype.nt = function (a, b, c) {
        return this.nv(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bs.bv, this.bs.bu, this.getEffectiveViewport1(this.bs)), this.yAxis, this.xAxis, null, null, null);
    };
    HorizontalRangeCategorySeries.prototype.qo = function () {
        return this.yAxis != null && this.yAxis.cn();
    };
    HorizontalRangeCategorySeries.prototype.kp = function (a, b, c, d) {
        _super.prototype.kp.call(this, a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.jp(typeCast(Axis.$, c));
                this.ku(typeCast(Axis.$, d));
                this.p3.cr.g(this.fq);
                this.k3(false);
                this.ka();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.jp(typeCast(Axis.$, c));
                this.ku(typeCast(Axis.$, d));
                this.p3.cr.g(this.fq);
                this.qo();
                this.k3(false);
                this.ka();
                break;
        }
    };
    HorizontalRangeCategorySeries.prototype.r2 = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HorizontalRangeCategorySeries.prototype.r1 = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b7) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalRangeCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.qp;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
    HorizontalRangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::r5', [CategoryAxisBase.$, null], 'YAxis::r6', [NumericYAxis.$, null]]);
    return HorizontalRangeCategorySeries;
}(RangeCategorySeries));
export { HorizontalRangeCategorySeries };
//# sourceMappingURL=HorizontalRangeCategorySeries.js.map