/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Describes available locations of the axis labels in the chart.
 */
export var SeriesVisibleRangeMode;
(function (SeriesVisibleRangeMode) {
    /**
     * Visible range mode is managed by the component.
     */
    SeriesVisibleRangeMode[SeriesVisibleRangeMode["Auto"] = 0] = "Auto";
    /**
     * Only the series values are considered for evaluating the visible range.
     */
    SeriesVisibleRangeMode[SeriesVisibleRangeMode["ValuesOnly"] = 1] = "ValuesOnly";
    /**
     * The reference value is included in the series visible range.
     */
    SeriesVisibleRangeMode[SeriesVisibleRangeMode["IncludeReferenceValue"] = 2] = "IncludeReferenceValue";
})(SeriesVisibleRangeMode || (SeriesVisibleRangeMode = {}));
/**
 * @hidden
 */
export var SeriesVisibleRangeMode_$type = markEnum('SeriesVisibleRangeMode', 'Auto,0|ValuesOnly,1|IncludeReferenceValue,2');
//# sourceMappingURL=SeriesVisibleRangeMode.js.map