/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { SlowStochasticOscillatorIndicatorStrategy } from "./SlowStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
var SlowStochasticOscillatorIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(SlowStochasticOscillatorIndicator, _super);
    function SlowStochasticOscillatorIndicator() {
        var _this = _super.call(this) || this;
        _this.trendLineBrush = ((function () {
            var $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        _this.trendLineType = 10;
        _this.trendLinePeriod = 3;
        return _this;
    }
    SlowStochasticOscillatorIndicator.prototype.get_sk = function () {
        return new SlowStochasticOscillatorIndicatorStrategy();
    };
    Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "sk", {
        get: function () {
            return this.get_sk();
        },
        enumerable: true,
        configurable: true
    });
    SlowStochasticOscillatorIndicator.prototype.get_sx = function () {
        return SlowStochasticOscillatorIndicator.$;
    };
    Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "sx", {
        get: function () {
            return this.get_sx();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "s5", {
        get: function () {
            return typeGetValue(this.c(SlowStochasticOscillatorIndicator.s6));
        },
        set: function (a) {
            this.h(SlowStochasticOscillatorIndicator.s6, a);
        },
        enumerable: true,
        configurable: true
    });
    SlowStochasticOscillatorIndicator.prototype.sq = function () {
        return this.s5;
    };
    SlowStochasticOscillatorIndicator.prototype.sz = function (a) {
        this.s5 = a;
    };
    SlowStochasticOscillatorIndicator.$t = markType(SlowStochasticOscillatorIndicator, 'SlowStochasticOscillatorIndicator', StrategyBasedIndicator.$);
    SlowStochasticOscillatorIndicator.s6 = StrategyBasedIndicator.s2(14, SlowStochasticOscillatorIndicator.$);
    return SlowStochasticOscillatorIndicator;
}(StrategyBasedIndicator));
export { SlowStochasticOscillatorIndicator };
//# sourceMappingURL=SlowStochasticOscillatorIndicator.js.map