import * as tslib_1 from "tslib";
import { IgxAssigningSeriesStyleEventArgsBase } from "./igx-assigning-series-style-event-args-base";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*/
var IgxAssigningSeriesShapeStyleEventArgsBase = /** @class */ (function (_super) {
    tslib_1.__extends(IgxAssigningSeriesShapeStyleEventArgsBase, _super);
    function IgxAssigningSeriesShapeStyleEventArgsBase() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "strokeThickness", {
        /**
         * Gets or sets stroke thickness to use for the current item.
        */
        get: function () {
            return this.i.t;
        },
        set: function (v) {
            this.i.t = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "radiusX", {
        /**
         * Gets or sets corner radius X to use for the current item, if applicable.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "radiusY", {
        /**
         * Gets or sets corner radius Y to use for the current item, if applicable.
        */
        get: function () {
            return this.i.s;
        },
        set: function (v) {
            this.i.s = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxAssigningSeriesShapeStyleEventArgsBase;
}(IgxAssigningSeriesStyleEventArgsBase));
export { IgxAssigningSeriesShapeStyleEventArgsBase };
//# sourceMappingURL=igx-assigning-series-shape-style-event-args-base.js.map