import { Base, Type } from "igniteui-angular-core";
import { SRProvider } from "igniteui-angular-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
/**
 * @hidden
 */
export declare class FinancialChartRangeSelectorViewModel extends Base {
    static $t: Type;
    b: SRProvider;
    private _notifyChanged;
    notifyChanged: () => void;
    private _options;
    options: FinancialChartRangeSelectorOptionCollection;
    private u;
    selectionStart: Date;
    private t;
    selectionEnd: Date;
    private _oneMonthChecked;
    oneMonthChecked: boolean;
    private _threeMonthsChecked;
    threeMonthsChecked: boolean;
    private _sixMonthsChecked;
    sixMonthsChecked: boolean;
    private _yearToDateChecked;
    yearToDateChecked: boolean;
    private _oneYearChecked;
    oneYearChecked: boolean;
    private _allChecked;
    allChecked: boolean;
    private _oneMonthVisible;
    oneMonthVisible: boolean;
    private _threeMonthsVisible;
    threeMonthsVisible: boolean;
    private _sixMonthsVisible;
    sixMonthsVisible: boolean;
    private _yearToDateVisible;
    yearToDateVisible: boolean;
    private _oneYearVisible;
    oneYearVisible: boolean;
    private _allVisible;
    allVisible: boolean;
    ao(): void;
    readonly financialChart_RangeSelector_OneMonth: string;
    readonly financialChart_RangeSelector_ThreeMonths: string;
    readonly financialChart_RangeSelector_SixMonths: string;
    readonly financialChart_RangeSelector_YearToDate: string;
    readonly financialChart_RangeSelector_OneYear: string;
    readonly financialChart_RangeSelector_All: string;
    readonly financialChart_RangeSelector_From: string;
    readonly financialChart_RangeSelector_To: string;
    private s;
    rangeStart: Date;
    private r;
    rangeEnd: Date;
    onPropertiesChanged(): boolean;
    readonly oneYearFromEnd: Date;
    readonly firstDayOfEndYear: Date;
    readonly sixMonthsFromEnd: Date;
    readonly threeMonthsFromEnd: Date;
    readonly oneMonthFromEnd: Date;
    changeSelection(a: string): void;
    onRadioButtonChanged(): void;
    private _onRangeChanged;
    onRangeChanged: () => void;
}
