import { StackedBarSeries } from "./StackedBarSeries";
import { IStacked100Series } from "./IStacked100Series";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { CategorySeriesView } from "./CategorySeriesView";
import { StackedBarSeriesView } from "./StackedBarSeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
/**
 * @hidden
 */
export declare class Stacked100BarSeries extends StackedBarSeries implements IStacked100Series {
    static $t: Type;
    protected get_ru(): boolean;
    constructor();
    ac(): void;
    protected bp(): SeriesView;
    sy: Stacked100BarSeriesView;
    kk(a: SeriesView): void;
    rm(): CategorySeriesView;
    protected sa(): void;
    readonly useHighMarkerFidelity: boolean;
}
/**
 * @hidden
 */
export declare class Stacked100BarSeriesView extends StackedBarSeriesView {
    static $t: Type;
    c6: Stacked100BarSeries;
    constructor(a: Stacked100BarSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
