import { Type } from '@angular/core';
import { IgxStackedAreaSeriesComponent } from "./igx-stacked-area-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { Stacked100AreaSeries } from "./Stacked100AreaSeries";
/**
 * Represents a stacked area series, where values are presented as percentages of the total.
*/
export declare const IgxStacked100AreaSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxStacked100AreaSeriesComponent extends IgxStackedAreaSeriesComponent {
    protected createImplementation(): Stacked100AreaSeries;
    /**
                                 * @hidden
                                 */
    readonly i: Stacked100AreaSeries;
    constructor();
    readonly isPercentBased: boolean;
}
