import { Type } from '@angular/core';
import { IgxStackedSplineSeriesComponent } from "./igx-stacked-spline-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { Stacked100SplineSeries } from "./Stacked100SplineSeries";
/**
 * Represents a IgxDataChartComponent stacked100 spline series.
*/
export declare const IgxStacked100SplineSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxStacked100SplineSeriesComponent extends IgxStackedSplineSeriesComponent {
    protected createImplementation(): Stacked100SplineSeries;
    /**
                                 * @hidden
                                 */
    readonly i: Stacked100SplineSeries;
    constructor();
    readonly isPercentBased: boolean;
}
